﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Input;

using Microsoft.Phone.Scheduler;

namespace DanielVaughan.WindowsPhone7Unleashed.Alarms
{
	public class AlarmViewModel : ViewModelBase
	{
		public AlarmViewModel()
		{
			alarmSetCommand = new DelegateCommand(obj => SetAlarm());
		}

		void SetAlarm()
		{
			Alarm alarm = new Alarm(alarmName)
			              	{
			              		BeginTime = alarmBeginTime, 
								ExpirationTime = alarmExpirationTime,
			              		Content = alarmContent, 
								RecurrenceType = alarmRecurrenceType, 
								Sound = alarmSound,
								/* Alarm does not support setting the Title. */
								// Title = alarmTitle 
			              	};

//			Alarm alarm = new Alarm(alarmName)
//			{
//				BeginTime = DateTime.Now.AddDays(1),
//				Content = "A test alarm.",
//				RecurrenceType = RecurrenceInterval.None,
//				Sound = new Uri("/Sounds/Alarm.wma", UriKind.Relative),
//			};

			if (ScheduledActionService.Find(alarm.Name) != null)
			{
				ScheduledActionService.Remove(alarm.Name);
			}

			ScheduledActionService.Add(alarm);

			MessageService.ShowMessage("alarm set");

//			for (int i = 0; i < 40; i++)
//			{
//				Alarm alarm2 = new Alarm("Alarm" + i)
//				{
//					BeginTime = DateTime.Now.AddSeconds(60 + i),
//					ExpirationTime = DateTime.Now.AddDays(5),
//					Content = "Alarm " + i,
//					RecurrenceType = RecurrenceInterval.None
//				};
//				ScheduledActionService.Add(alarm2);
//			}
		}

		readonly DelegateCommand alarmSetCommand;

		public ICommand AlarmSetCommand
		{
			get
			{
				return alarmSetCommand;
			}
		}

		DateTime alarmBeginTime = DateTime.Now.AddSeconds(20);

		public DateTime AlarmBeginTime
		{
			get
			{
				return alarmBeginTime;
			}
			set
			{
				Assign(() => AlarmBeginTime, ref alarmBeginTime, value);
			}
		}

		DateTime alarmExpirationTime = DateTime.Now.AddDays(14);

		public DateTime AlarmExpirationTime
		{
			get
			{
				return alarmExpirationTime;
			}
			set
			{
				Assign(() => AlarmExpirationTime, ref alarmExpirationTime, value);
			}
		}

		string alarmName = "default alarm";

		public string AlarmName
		{
			get
			{
				return alarmName;
			}
			set
			{
				Assign(() => AlarmName, ref alarmName, value);
			}
		}

		readonly Uri alarmSound = new Uri("/Sounds/Alarm.wma", UriKind.Relative);

		public Uri AlarmSound
		{
			get
			{
				return alarmSound;
			}
		}

		string alarmContent = "test content";

		public string AlarmContent
		{
			get
			{
				return alarmContent;
			}
			set
			{
				Assign(() => AlarmContent, ref alarmContent, value);
			}
		}

		RecurrenceInterval alarmRecurrenceType;

		public RecurrenceInterval AlarmRecurrenceType
		{
			get
			{
				return alarmRecurrenceType;
			}
			set
			{
				Assign(() => AlarmRecurrenceType, ref alarmRecurrenceType, value);
			}
		}

		readonly IEnumerable<RecurrenceInterval> recurrenceIntervals 
					= EnumUtility.CreateEnumValueList<RecurrenceInterval>();

		public IEnumerable<RecurrenceInterval> RecurrenceIntervals
		{
			get
			{
				return recurrenceIntervals;
			}
		}
	}
}
