﻿using System.Windows;
using System.Windows.Navigation;

using Microsoft.Phone.Controls;

namespace DanielVaughan.WindowsPhone7Unleashed.TodoList
{
	public partial class TodoItemView : PhoneApplicationPage
	{
		readonly TodoItemViewModel viewModel;
		bool initialized;

		public TodoItemView()
		{
			InitializeComponent();

			var todoService = Dependency.Resolve<ITodoService, TodoService>();
			DataContext = viewModel = new TodoItemViewModel(todoService);
		}

		protected override void OnNavigatedTo(NavigationEventArgs e)
		{
			base.OnNavigatedTo(e);

			if (initialized)
			{
				return;
			}
			initialized = true;

			string itemId;
			if (NavigationContext.QueryString.TryGetValue("TodoItemId", out itemId))
			{
				/* Custom commanding infrastructure performs automatic conversion 
				 * from a string to an int. */
				viewModel.LoadItemCommand.Execute(itemId);
			}
			VisualStateManager.GoToState(this, viewModel.VisualState, true);
		}
	}
}