using System;
using System.Collections.Generic;

namespace DanielVaughan.WindowsPhone7Unleashed.TodoList
{
	public interface ITodoService
	{
		IEnumerable<TodoItem> GetTodoItems();
		/// <summary>
		/// Gets the <see cref="TodoItem"/> with the specified id.
		/// </summary>
		/// <exception cref="KeyNotFoundException">
		/// Occurs if an item is not located with the specified key.</exception>
		TodoItem GetTodoItem(int itemId);

		bool TryGetTodoItem(int itemId, out TodoItem todoItem);
		void AddOrUpdateItem(TodoItem todoItem);
		void RemoveTodoItem(TodoItem todoItem);

		void Initialize();
	}
}