﻿using System;

using Microsoft.Phone.Shell;

namespace DanielVaughan.WindowsPhone7Unleashed.TodoList
{
	public static class TodoTileDataCreator
	{
		public static StandardTileData CreateTile(
			string todoItemDescription, DateTime dueDate)
		{
			/* The Count property of the tile data is set 
			 * to the number of days remaining. 
			 * It must be between 0 and 99 inclusively. */
			int daysUntilDue = 0;
			bool overdue = DateTime.Now > dueDate;
			if (!overdue)
			{
				int temp = (int)(DateTime.Now - dueDate).TotalDays;
				if (temp < 100)
				{
					daysUntilDue = temp;
				}
			}

			const string tilesDirectory = "/TodoList/Images/Tiles/";

			string backgroundUrl = overdue
										? tilesDirectory + "Overdue.jpg"
										: tilesDirectory + "Ok.jpg";

			StandardTileData tileData = new StandardTileData
				{
					Title = todoItemDescription,
					BackgroundImage = new Uri(backgroundUrl, UriKind.Relative),
					Count = overdue ? 0 : daysUntilDue,

					BackTitle = dueDate.ToShortDateString(),
					BackContent = todoItemDescription,//overdue ? "overdue" : "due on",
					BackBackgroundImage = new Uri(
						tilesDirectory + "Background.jpg", UriKind.Relative)
				};

			return tileData;
		}
	}
}
