﻿using System.Diagnostics;
using System.IO;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Threading;
using System.Web;

namespace WindowsPhone7Unleashed.BackgroundAgents.Web
{
	[ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
	[AspNetCompatibilityRequirements(
		RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
	public class BackupService : IBackupService
	{
		public void SaveFile(string userId, string fileName, Stream fileStream)
		{
			Debug.WriteLine("SaveFile: " + fileName);
			string location = string.Format(@"~\Backups\{0}_{1}", userId, fileName);
			var filepath = HttpContext.Current.Server.MapPath(location);
			using (Stream outputStream = File.OpenWrite(filepath))
			{
				CopyStream(fileStream, outputStream);
			}
		}

		static void CopyStream(Stream input, Stream output)
		{
			var buffer = new byte[8 * 1024];
			int streamLength;

			while ((streamLength = input.Read(buffer, 0, buffer.Length)) > 0)
			{
				output.Write(buffer, 0, streamLength);
				//Thread.Sleep(200);
			}
		}
	}
}
