﻿using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Windows;
using System.Windows.Navigation;

using DanielVaughan.Data;

using Microsoft.Phone.Controls;

namespace DanielVaughan.WindowsPhone7Unleashed.BackgroundAudio
{
	public partial class MainPage : PhoneApplicationPage
	{
		readonly MainPageViewModel viewModel = new MainPageViewModel(
												new BackgroundAudioPlayerProxy(),
												new IsolatedStorageUtility());

		MainPageViewModel ViewModel
		{
			get
			{
				return (MainPageViewModel)DataContext;
			}
		}

		public MainPage()
		{
			InitializeComponent();

			DataContext = viewModel;

			viewModel.PropertyChanged 
				+= (sender, args) =>
				   	{
						if (args.PropertyName == "VisualState")
				   		{
							SetVisualState();
				   		}
				   	};
		}

		protected override void OnNavigatedTo(NavigationEventArgs e)
		{
			base.OnNavigatedTo(e);

			SetVisualState();
		}

		void SetVisualState()
		{
			VisualStateManager.GoToState(this, ViewModel.VisualState, true);
		}
	}
}