﻿using System;

using Microsoft.Phone.BackgroundAudio;

namespace DanielVaughan.WindowsPhone7Unleashed.BackgroundAudio
{
	public class BackgroundAudioPlayerProxy : IBackgroundAudioPlayer
	{
		public void Close()
		{
			BackgroundAudioPlayer.Instance.Close();
		}

		public void FastForward()
		{
			BackgroundAudioPlayer.Instance.FastForward();
		}

		public void Pause()
		{
			BackgroundAudioPlayer.Instance.Pause();
		}

		public void Play()
		{
			BackgroundAudioPlayer.Instance.Play();
		}

		public void Rewind()
		{
			BackgroundAudioPlayer.Instance.Rewind();
		}

		public void SkipNext()
		{
			BackgroundAudioPlayer.Instance.SkipNext();
		}

		public void SkipPrevious()
		{
			BackgroundAudioPlayer.Instance.SkipPrevious();
		}

		public void Stop()
		{
			BackgroundAudioPlayer.Instance.Stop();
		}

		public double BufferingProgress
		{
			get
			{
				return BackgroundAudioPlayer.Instance.BufferingProgress;
			}
		}

		public bool CanPause
		{
			get
			{
				return BackgroundAudioPlayer.Instance.CanPause;
			}
		}

		public bool CanSeek
		{
			get
			{
				return BackgroundAudioPlayer.Instance.CanSeek;
			}
		}

		public Exception Error
		{
			get
			{
				return BackgroundAudioPlayer.Instance.Error;
			}
		}

		public PlayState PlayerState
		{
			get
			{
				return BackgroundAudioPlayer.Instance.PlayerState;
			}
		}

		public TimeSpan Position
		{
			get
			{
				return BackgroundAudioPlayer.Instance.Position;
			}
			set
			{
				BackgroundAudioPlayer.Instance.Position = value;
			}
		}

		public AudioTrack Track
		{
			get
			{
				return BackgroundAudioPlayer.Instance.Track;
			}
			set
			{
				BackgroundAudioPlayer.Instance.Track = value;
			}
		}

		public double Volume
		{
			get
			{
				return BackgroundAudioPlayer.Instance.Volume;
			}
			set
			{
				BackgroundAudioPlayer.Instance.Volume = value;
			}
		}

		public event EventHandler PlayStateChanged
		{
			add
			{
				BackgroundAudioPlayer.Instance.PlayStateChanged += value;
			}
			remove
			{
				BackgroundAudioPlayer.Instance.PlayStateChanged -= value;
			}
		}
	}
}
