﻿using System;

using Microsoft.Phone.BackgroundAudio;

namespace DanielVaughan.WindowsPhone7Unleashed.BackgroundAudio
{
	public class MockBackgroundAudioPlayer : IBackgroundAudioPlayer
	{
		public bool CloseCalled { get; set; }

		public void Close()
		{
			CloseCalled = true;
		}

		public bool FastForwardCalled { get; set; }

		public void FastForward()
		{
			FastForwardCalled = true;
		}

		public bool PauseCalled { get; set; }

		public void Pause()
		{
			PauseCalled = true;
		}

		public bool PlayCalled { get; set; }

		public void Play()
		{
			PlayCalled = true;
		}

		public bool RewindCalled { get; set; }

		public void Rewind()
		{
			RewindCalled = true;
		}

		public bool SkipNextCalled { get; set; }

		public void SkipNext()
		{
			SkipNextCalled = true;
		}

		public bool SkipPreviousCalled { get; set; }

		public void SkipPrevious()
		{
			SkipPreviousCalled = true;
		}

		public bool StopCalled { get; set; }

		public void Stop()
		{
			StopCalled = true;
		}

		public double BufferingProgress { get; set; }

		public bool CanPause { get; set; }

		public bool CanSeek { get; set; }

		public Exception Error { get; set; }

		public PlayState PlayerState { get; set; }

		public TimeSpan Position { get; set; }

		public AudioTrack Track { get; set; }

		public double Volume { get; set; }

		public event EventHandler PlayStateChanged;

		public void RaisePlayStateChanged(EventArgs e)
		{
			var tempEvent = PlayStateChanged;
			if (tempEvent != null)
			{
				tempEvent(this, e);
			}
		}
	}
}
