﻿using System;
using System.Globalization;
using System.IO.IsolatedStorage;
using System.Windows.Data;
using System.Windows.Media.Imaging;

using DanielVaughan.WindowsPhone7Unleashed.Data.ImageCache;

namespace DanielVaughan.WindowsPhone7Unleashed.ValueConverters
{
	/// <summary>
	/// Provides image cache support for Image Source bindings.
	/// </summary>
	public class ImageCacheConverter : IValueConverter
	{
		public object Convert(object value, Type targetType,
			object parameter, CultureInfo culture)
		{
			if (EnvironmentValues.DesignTime)
			{
				return value;
			}

			string url = value as string;
			if (url != null)
			{
				try
				{
					return ImageCache.GetImage(new BitmapImage(new Uri(url)));
				}
				catch (IsolatedStorageException e)
				{
					Console.WriteLine(e);
					return value;
				}
			}

			BitmapImage bitmapImage = value as BitmapImage;
			if (bitmapImage != null)
			{
				return ImageCache.GetImage(bitmapImage);
			}
			return value;
		}

		public object ConvertBack(object value, Type targetType,
			object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}
