﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;

namespace DanielVaughan
{
	public static class EnumUtility
	{
		public static IEnumerable<TEnum> CreateEnumValueList<TEnum>()
		{
			Type enumType = typeof(TEnum);
			IEnumerable<FieldInfo> fieldInfos 
				= enumType.GetFields().Where(x => enumType.Equals(x.FieldType));
			return fieldInfos.Select(
				fieldInfo => (TEnum)Enum.Parse(enumType, fieldInfo.Name, true)).ToList();
		}
	}
}
