﻿#region File and License Information
/*
<File>
	<Copyright>Copyright © 2009, Daniel Vaughan. All rights reserved.</Copyright>
	<License>
	This file is part of DanielVaughan's core library

	DanielVaughan's core library is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	DanielVaughan's core library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with DanielVaughan's core library.  If not, see http://www.gnu.org/licenses/.
	</License>
	<Owner Name="Daniel Vaughan" Email="dbvaughan@gmail.com"/>
	<CreationDate>2010-12-27 15:13:08Z</CreationDate>
	<Origin>http://www.calciumsdk.com</Origin>
</File>
*/
#endregion

using System;

namespace DanielVaughan.InversionOfControl.Containers
{
	/* TODO: [DV] Comment. */
	public class SimpleContainerRegistrar : IDependencyRegistrar
	{
		IContainer Container
		{
			get
			{
				return Dependency.Resolve<IContainer>();
			}
		}

		public bool IsTypeRegistered(Type type)
		{
			return Container.IsRegistered(type);
		}

		public void Register<TFrom, TTo>(bool singleton = false, string key = null) where TTo : TFrom
		{
			Container.Register<TFrom, TTo>(singleton, key);
		}

		public void Register(Type fromType, Type toType, bool singleton = false, string key = null)
		{
			Container.Register(fromType, toType, singleton, key);
		}

		public void Register<TFrom>(TFrom instance, string key = null)
		{
			Container.Register<TFrom>(instance, key);
		}

		public void Register(Type type, object instance, string key = null)
		{
			Container.Register(type, instance, key);
		}
	}
}
