﻿#region File and License Information
/*
<File>
	<Copyright>Copyright © 2009, Daniel Vaughan. All rights reserved.</Copyright>
	<License>
	This file is part of DanielVaughan's core library

	DanielVaughan's core library is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	DanielVaughan's core library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with DanielVaughan's core library.  If not, see http://www.gnu.org/licenses/.
	</License>
	<Owner Name="Daniel Vaughan" Email="dbvaughan@gmail.com"/>
	<CreationDate>2010-12-27 15:13:08Z</CreationDate>
	<Origin>http://www.calciumsdk.com</Origin>
</File>
*/
#endregion

using System;
using System.Collections.Generic;

namespace DanielVaughan.InversionOfControl
{
	public interface IContainer
	{
		void Register<TFrom, TTo>(bool singleton = false, string key = null) where TTo : TFrom;
		void Register(Type fromType, Type toType, bool singleton = false, string key = null);
		void Register<TInterface>(TInterface instance, string key = null);
		void Register(Type type, object instance, string key = null);
		bool IsRegistered<T>();
		bool IsRegistered(Type fromType);
		T Resolve<T>(string key = null);
		object Resolve(Type type, string key = null);
		IEnumerable<TFrom> ResolveAll<TFrom>() where TFrom : class;
		IEnumerable<Object> ResolveAll(Type fromType);
	}
}