﻿#region File and License Information
/*
<File>
	<Copyright>Copyright © 2009, Daniel Vaughan. All rights reserved.</Copyright>
	<License>
	This file is part of Calcium.

	Calcium is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Calcium is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Calcium.  If not, see http://www.gnu.org/licenses/.
	</License>
	<Owner Name="Daniel Vaughan" Email="dbvaughan@gmail.com"/>
	<CreationDate>2009-10-14 16:34:20Z</CreationDate>
	<Origin>http://www.calciumsdk.com</Origin>
</File>
*/
#endregion

using System;

namespace DanielVaughan.InversionOfControl
{
	/// <summary>
	/// Allows setting of type to type, or type to instance associations
	/// in the service container.
	/// </summary>
	public interface IDependencyRegistrar
	{
		bool IsTypeRegistered(Type type);
		void Register<TFrom, TTo>(bool singleton = false, string key = null) where TTo : TFrom;
		void Register(Type fromType, Type toType, bool singleton = false, string key = null);
		void Register<TFrom>(TFrom instance, string key = null);
		void Register(Type type, object instance, string key = null);
	}
}
