﻿using System.ComponentModel;

namespace DanielVaughan.WindowsPhone7Unleashed.Localizability
{
	public sealed class BindableChangeNotifier<T> : INotifyPropertyChanged
	{
		public event PropertyChangedEventHandler PropertyChanged;

		static T instance;

		public T Instance
		{
			get
			{
				return instance;
			}
		}

		public BindableChangeNotifier(T observableObject)
		{
			instance = observableObject;
		}

		public void RaisePropertyChanged()
		{
			var temp = PropertyChanged;
			if (temp != null)
			{
				temp(this, new PropertyChangedEventArgs(string.Empty));
			}
		}
	}
}
