﻿#region File and License Information
/*
<File>
	<Copyright>Copyright © 2009, Daniel Vaughan. All rights reserved.</Copyright>
	<License>
	This file is part of DanielVaughan's Core library

	DanielVaughan's Core library is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	DanielVaughan's Core library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with DanielVaughan's Core library.  If not, see http://www.gnu.org/licenses/.
	</License>
	<Owner Name="Daniel Vaughan" Email="dbvaughan@gmail.com"/>
	<CreationDate>2010-12-28 21:07:13Z</CreationDate>
	<Origin>http://www.calciumsdk.com</Origin>
</File>
*/
#endregion

using System;

namespace DanielVaughan.Services.Implementation
{
	public class MockMessageService : MessageServiceBase
	{
		public string Message { get; set; }
		public string Caption { get; set; }
		public MessageButton MessageButton { get; set; }
		public MessageImage MessageImage { get; set; }
		public MessageImportance? ImportanceThreshold { get; set; }
		public string Details { get; set; }
		
		MessageResult showCustomDialogResult = MessageResult.Ok;

		public MessageResult ShowCustomDialogResult
		{
			get
			{
				return showCustomDialogResult;
			}
			set
			{
				showCustomDialogResult = value;
			}
		}

		public override MessageResult ShowCustomDialog(
			string message,
			string caption,
			MessageButton messageButton,
			MessageImage messageImage,
			MessageImportance? importanceThreshold,
			string details)
		{
			Message = message;
			Caption = caption;
			MessageButton = messageButton;
			MessageImage = messageImage;
			ImportanceThreshold = importanceThreshold;
			Details = details;

			return showCustomDialogResult;
		}

		public object QuestionWithTextResponseMock { get; set; }
		public TextResponse TextResponse { get; set; }

		public override void AskQuestion<TResponse>(
			IQuestion<TResponse> question, 
			Action<QuestionResult<TResponse>> resultHandler)
		{
			resultHandler(new QuestionResult<TResponse>(
				(TResponse)QuestionWithTextResponseMock, question));
		}
	}
}
