﻿#region File and License Information
/*
<File>
	<Copyright>Copyright © 2009, Daniel Vaughan. All rights reserved.</Copyright>
	<License>
	This file is part of DanielVaughan's core library

	DanielVaughan's core library is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	DanielVaughan's core library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with DanielVaughan's core library.  If not, see http://www.gnu.org/licenses/.
	</License>
	<Owner Name="Daniel Vaughan" Email="dbvaughan@gmail.com"/>
	<CreationDate>2010-12-10 13:05:43Z</CreationDate>
</File>
*/
#endregion

using System;
using System.Runtime.Serialization;

namespace DanielVaughan.Services
{
	/* TODO: [DV] Comment. */
	public class TextResponseQuestion : IQuestion<TextResponse>
	{
		[DataMember]
		public string Question { get; set; }

		[DataMember]
		public TextResponseQuestionType QuestionType { get; set; }

		[DataMember]
		public string Caption { get; set; }

		[DataMember]
		public string ValidationExpression { get; set; }

		[DataMember]
		public string ValidationFailedMessage { get; set; }

		[DataMember]
		public string Details { get; set; }

		[DataMember]
		public string DefaultResponse { get; set; }

		public TextResponseQuestion(
			string question,
			TextResponseQuestionType questionType = TextResponseQuestionType.Default)
		{
			Question = question;
			QuestionType = questionType;
		}

		internal TextResponseQuestion()
		{
			/* Intentionally left blank. */
		}
	}

	/* TODO: [DV] Comment. */
	public enum TextResponseQuestionType
	{
		Default,
		Url,
		PhoneNumber,
		EmailAddress,
		Contact
	}

	/* TODO: [DV] Comment. */
	public class TextResponse : IQuestionResult
	{
		[DataMember]
		public string Text { get; set; }

		[DataMember]
		public OkCancelQuestionResult OkCancelQuestionResult { get; set; }

		public TextResponse(OkCancelQuestionResult result, string answer)
		{
			OkCancelQuestionResult = result;
			Text = answer;
		}

		internal TextResponse()
		{
			/* Intentionally left blank. */
		}

		public bool HasValidAnswer
		{
			get
			{
				return OkCancelQuestionResult == OkCancelQuestionResult.Ok
					&& Text != null;
			}
		}
	}
}