﻿using System.IO.IsolatedStorage;
using System.Windows;
using System.Windows.Navigation;

using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public static class StateManager
	{
		public static void Initialize()
		{
			PhoneApplicationService.Current.Deactivated += OnDeactivated;
			var frame = (PhoneApplicationFrame)Application.Current.RootVisual;
			frame.Navigating += OnNavigating;
			frame.Navigated += OnNavigated;
		}

		static void OnNavigating(object sender, NavigatingCancelEventArgs e)
		{
			var frame = (PhoneApplicationFrame)Application.Current.RootVisual;
			var element = frame.Content as FrameworkElement;
			if (element != null)
			{
				IStatePreservation preserver 
					= element.DataContext as IStatePreservation;
				if (preserver != null)
				{
					preserver.SaveState(
						IsolatedStorageSettings.ApplicationSettings, 
						PhoneApplicationService.Current.State);
				}
			}
		}

		static void OnNavigated(object sender, NavigationEventArgs e)
		{
			var element = e.Content as FrameworkElement;
			if (element != null)
			{
				IStatePreservation statePreservation 
					= element.DataContext as IStatePreservation;
				if (statePreservation != null)
				{
					statePreservation.LoadState(
						IsolatedStorageSettings.ApplicationSettings, 
						PhoneApplicationService.Current.State,
                        shouldLoadTransientState);
				}
			}
		}
		
		static void OnDeactivated(object sender, DeactivatedEventArgs e)
		{
			shouldLoadTransientState = false;
		}

		static bool shouldLoadTransientState = true;

		public static bool ShouldLoadTransientState
		{
			get
			{
				return shouldLoadTransientState;
			}
		}
	}
}
