﻿using System;
using System.Collections.Generic;

namespace DanielVaughan.WindowsPhone7Unleashed.InputValidation
{
	public class ValidationCompleteEventArgs : EventArgs
	{
		public Exception Exception { get; private set; }
		public string PropertyName { get; private set; }
		public IEnumerable<DataValidationError> Errors { get; private set; }

		public ValidationCompleteEventArgs(string propertyName)
		{
			PropertyName = ArgumentValidator.AssertNotNull(
				propertyName, "propertyName"); ;
		}

		public ValidationCompleteEventArgs(string propertyName, 
		                                   IEnumerable<DataValidationError> errors)
			: this(propertyName)
		{
			Errors = errors;
		}

		public ValidationCompleteEventArgs(string propertyName, Exception exception)
			: this(propertyName)
		{
			Exception = exception;
		}
	}
}