﻿using System;
using System.Globalization;
using System.IO;
using System.IO.IsolatedStorage;
using System.Windows.Data;
using System.Windows.Media.Imaging;

namespace DanielVaughan.WindowsPhone7Unleashed.ValueConverters
{
	public class StringToImageConverter : IValueConverter
	{
		public object Convert(
			object value, Type targetType, object parameter, CultureInfo culture)
		{
			if (value == null)
			{
				return null;
			}

			using (IsolatedStorageFile storageFile 
						= IsolatedStorageFile.GetUserStoreForApplication())
			{
				using (IsolatedStorageFileStream stream 
							= storageFile.OpenFile(value.ToString(), FileMode.Open))
				{
					BitmapImage image = new BitmapImage();
					image.SetSource(stream);
					return image;
				}
			}
		}

		public object ConvertBack(
			object value, Type targetType, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}
