﻿using System;
using System.Windows.Media.Imaging;

namespace DanielVaughan.WindowsPhone7Unleashed.Windows
{
	public static class BitmapExtensions
	{
		public static void FromByteArray(
			this WriteableBitmap writeableBitmap, byte[] buffer)
		{
			Buffer.BlockCopy(buffer, 0, writeableBitmap.Pixels, 0, buffer.Length);
		}

		public static byte[] ToByteArray(this WriteableBitmap writableBitmap)
		{
			ArgumentValidator.AssertNotNull(writableBitmap, "writableBitmap");
			int[] pixels = writableBitmap.Pixels;
			int arrayLength = pixels.Length * 4;
			byte[] result = new byte[arrayLength];
			Buffer.BlockCopy(pixels, 0, result, 0, arrayLength);
			return result;
		}
	}
}
