﻿using System.Windows;
using System.Windows.Data;

using DanielVaughan.WindowsPhone7Unleashed.Examples.BingMaps.Routing;

using Microsoft.Phone.Controls;
using Microsoft.Phone.Controls.Maps;
using Microsoft.Phone.Controls.Maps.Core;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public partial class BingMapsView : PhoneApplicationPage
	{
		public BingMapsView()
		{
            var viewModel = new BingMapsViewModel(new RouteCalculator(
                        new ApplicationIdCredentialsProvider(
                                App.BingMapsId)));

            DataContext = viewModel;

			InitializeComponent();
			map.Pitch = .5;

			viewModel.PropertyChanged 
				+= (o, args) =>
			        {
			        	switch (args.PropertyName)
			        	{
							case "LocationRect":
								map.SetView(ViewModel.LocationRect);
			        			break;
			        	}
			        };

			Loaded += HandleLoaded;

			//			MapLayer mapLayer = new MapLayer();
			//			map.Children.Add(mapLayer);
			//			Pushpin pushpin = new Pushpin { Content = "Pushpin Example" };
			//			mapLayer.AddChild(pushpin, map.Center, PositionOrigin.Center);
		}

	    void HandleLoaded(object sender, RoutedEventArgs e)
	    {
	        Binding binding = new Binding("MapMode") {Source = ViewModel};
	        BindingOperations.SetBinding(map, MapBase.ModeProperty, binding);
	    }

	    BingMapsViewModel ViewModel
		{
			get
			{
				return (BingMapsViewModel)DataContext;
			}
		}

//		void Handle_ZoomIn_Tap(object sender, System.Windows.Input.GestureEventArgs e)
//		{
//			if (map.ZoomLevel < 21)
//			{
//				map.ZoomLevel += 1;
//			}
//		}
	}
}