﻿using System;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class MockChatService : IChatService
	{
		public bool MessageSent { get; private set; }
		public string LastMessage { get; private set; }

		public void SendMessage(string message)
		{
			MessageSent = true;
			LastMessage = message;
			OnMessageReceived(new ChatMessageEventArgs(message));
		}

		public event EventHandler<ChatMessageEventArgs> MessageReceived;

		public void OnMessageReceived(ChatMessageEventArgs e)
		{
			MessageReceived.Raise(this, e);
		}
	}
}