﻿using System;
using System.Collections.Generic;
using System.Windows.Input;

using Microsoft.Phone.UserData;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class AppointmentsViewModel : ViewModelBase
	{
        public AppointmentsViewModel() : base("appointments")
        {
            searchCommand = new DelegateCommand(arg => SearchAppointments());
        }

        Appointments appointments;

	    void SearchAppointments()
	    {
            appointments = new Appointments();
            appointments.SearchCompleted += HandleSearchCompleted;
            //            Account account = appointments.Accounts.Where(
            //                        x => x.Name == "Windows Live").First();
            appointments.SearchAsync(startTimeInclusive, endTimeInclusive, null);
	    }

	    void HandleSearchCompleted(object sender, AppointmentsSearchEventArgs e)
	    {
	        if (e.Results == null)
	        {
	            return;
	        }
	        Appointments = e.Results;
	    }

        IEnumerable<Appointment> appointmentList = new List<Appointment>();

        public IEnumerable<Appointment> Appointments
	    {
	        get
	        {
	            return appointmentList;
	        }
	        private set
	        {
                Assign(() => Appointments, ref appointmentList, value);
	        }
	    }

	    readonly DelegateCommand searchCommand;

		public ICommand SearchCommand
		{
			get
			{
				return searchCommand;
			}
		}

	    DateTime startTimeInclusive = DateTime.Now.AddYears(-1);

	    public DateTime StartTimeInclusive
	    {
	        get
	        {
	            return startTimeInclusive;
	        }
	        set
	        {
	            Assign(() => StartTimeInclusive, ref startTimeInclusive, value);
	        }
	    }

	    DateTime endTimeInclusive = DateTime.Now.AddYears(1);

	    public DateTime EndTimeInclusive
	    {
	        get
	        {
	            return endTimeInclusive;
	        }
	        set
	        {
	            Assign(() => EndTimeInclusive, ref endTimeInclusive, value);
	        }
	    }
	}
}
