﻿using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Media;

using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples.ControlExamples
{
	public partial class ApplicationBarView : PhoneApplicationPage
	{
		public ApplicationBarView()
		{
			InitializeComponent();
			ApplicationBarViewModel viewModel = new ApplicationBarViewModel();
			DataContext = viewModel;

			/* Let the viewmodel know what the foreground 
			 * and background colors are for the application bar. */
			Color foregroundColor = ((SolidColorBrush)Foreground).Color;
			Color backgroundColor = (Color)Resources["PhoneChromeColor"];
			viewModel.AddKnownColor(foregroundColor);
			viewModel.AddKnownColor(backgroundColor);
			viewModel.BackgroundColor = backgroundColor;
			viewModel.ForegroundColor = foregroundColor;
		}

		ApplicationBarViewModel ViewModel
		{
			get
			{
				return (ApplicationBarViewModel)DataContext;
			}
		}

		void AppBarMenuItem_Click(object sender, System.EventArgs e)
		{
			ViewModel.Message = "Click event raised.";
		}
	}

    public class ApplicationBarModeToBooleanConverter : IValueConverter
    {
        public object Convert(
            object value, Type targetType, object parameter, CultureInfo culture)
        {
            ApplicationBarMode mode = (ApplicationBarMode)value;
            return mode != ApplicationBarMode.Default;
        }

        public object ConvertBack(
            object value, Type targetType, object parameter, CultureInfo culture)
        {
            bool minimized = (bool)value;
            return minimized ? ApplicationBarMode.Minimized : ApplicationBarMode.Default;
        }
    }
}