﻿using System.Collections.ObjectModel;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class DeepZoomViewModel : ViewModelBase
	{
		public DeepZoomViewModel() : base("DeepZoom")
		{
			deepZoomSource = deepZoomSources[0];
		}

		DeepZoomSource deepZoomSource;

		public DeepZoomSource DeepZoomSource
		{
			get
			{
				return deepZoomSource;
			}
			set
			{
				Assign("DeepZoomSource", ref deepZoomSource, value);
			}
		}

		readonly ObservableCollection<DeepZoomSource> deepZoomSources
			= new ObservableCollection<DeepZoomSource>
			  	{
					new DeepZoomSource("Seadragon Blue Marble", 
						"http://static.seadragon.com/content/misc/blue-marble.dzi"),
					new DeepZoomSource("Seadragon Contoso Fixster", 
						"http://static.seadragon.com/content/misc/contoso-fixster.dzi"),
					new DeepZoomSource("Seadragon Color Flower", 
						"http://static.seadragon.com/content/misc/color-flower.dzi"),
					new DeepZoomSource("mont-saint-michel", 
						"http://gasi.ch/examples/2008/10/13/inside-deep-zoom/mont-saint-michel/silverlight/GeneratedImages/dzc_output.xml"),
			  		new DeepZoomSource("Local Web Server", 
						"http://localhost:27571/DeepZoom/dzc_output.xml")
			  	};

		public ObservableCollection<DeepZoomSource> DeepZoomSources
		{
			get
			{
				return deepZoomSources;
			}
		}
	}

	public class DeepZoomSource
	{
		public string Name { get; private set; }
		public string Url { get; private set; }

		public DeepZoomSource(string name, string url)
		{
			Name = name;
			Url = url;
		}
	}
}