﻿using System.Windows.Controls;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;

using Microsoft.Phone.Controls;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public partial class InkPresenterView : PhoneApplicationPage
	{
		public InkPresenterView()
		{
			InitializeComponent();
			DataContext = new InkPresenterViewModel();
		}

		InkPresenterViewModel ViewModel
		{
			get
			{
				return (InkPresenterViewModel)DataContext;
			}
		}

		void InkPresenter_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
		{
			InkPresenter inkPresenter = (InkPresenter)sender;
			ViewModel.BeginStrokeCommand.Execute(e.GetPosition(inkPresenter));
		}

		void InkPresenter_MouseMove(object sender, MouseEventArgs e)
		{
			InkPresenter inkPresenter = (InkPresenter)sender;
			ViewModel.SetStrokePointCommand.Execute(e.GetPosition(inkPresenter));
		}

		void InkPresenter_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
		{
			ViewModel.EndStrokeCommand.Execute(null);
		}

//		#region non-MVVM approach
//
//		readonly StrokeCollection strokes = new StrokeCollection();
//		Stroke stroke;
//
//		void InkPresenter_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
//		{
//			InkPresenter inkPresenter = (InkPresenter)sender;
//			stroke = new Stroke();
//			StylusPointCollection points = e.StylusDevice.GetStylusPoints(inkPresenter);
//			stroke.StylusPoints.Add(points);
//			stroke.DrawingAttributes.Color = Colors.White;
//			strokes.Add(stroke);
//			inkPresenter.Strokes = strokes;
//		}
//
//		void InkPresenter_MouseMove(object sender, MouseEventArgs e)
//		{
//			InkPresenter inkPresenter = (InkPresenter)sender;
//			if (stroke != null)
//			{
//				stroke.StylusPoints.Add(e.StylusDevice.GetStylusPoints(inkPresenter));
//			}
//		}
//
//		void InkPresenter_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
//		{
//			stroke = null;
//		}
//		#endregion
	}
}