﻿using System;
using System.ComponentModel;
using System.Windows;
using System.Windows.Controls;

using Microsoft.Phone.Controls;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public partial class MediaView : PhoneApplicationPage
	{
		public MediaView()
		{
			InitializeComponent();
			MediaViewModel viewModel = new MediaViewModel();
			DataContext = viewModel;
			/* Rather than subscribing to the PropertyChanged event, 
			 * you could use the IMessageBus to maintain weak references if needed. */
			viewModel.PropertyChanged += viewModel_PropertyChanged;
		}

		void viewModel_PropertyChanged(object sender, PropertyChangedEventArgs e)
		{
			if (e.PropertyName == "PlayerState")
			{
				switch (ViewModel.PlayerState)
				{
					case PlayerState.Stopped:
						mediaElement.Stop();
						break;
					case PlayerState.Playing:
						mediaElement.Play();
						break;
					case PlayerState.Paused:
						mediaElement.Pause();
						break;
				}
			}
		}

		MediaViewModel ViewModel
		{
			get
			{
				return (MediaViewModel)DataContext;
			}
		}

		void mediaElement_DownloadProgressChanged(object sender, RoutedEventArgs e)
		{
			MediaElement element = (MediaElement)sender;
			ViewModel.DownloadProgress = element.DownloadProgress;
			ViewModel.DownloadProgressOffset = element.DownloadProgressOffset;
		}

		void mediaElement_BufferingProgressChanged(object sender, RoutedEventArgs e)
		{
			MediaElement element = (MediaElement)sender;
			ViewModel.BufferingProgress = element.BufferingProgress;
			ViewModel.DownloadProgressOffset = element.DownloadProgressOffset;
		}

		void mediaElement_MediaOpened(object sender, RoutedEventArgs e)
		{
			MediaElement element = (MediaElement)sender;
			ViewModel.PlayLength = element.NaturalDuration.TimeSpan;
		}

		void mediaElement_CurrentStateChanged(object sender, RoutedEventArgs e)
		{
			MediaElement element = (MediaElement)sender;
			ViewModel.MediaElementState = element.CurrentState;
			ViewModel.CanSeek = element.CanSeek;
			ViewModel.CanPause = element.CanPause;
		}

		void mediaElement_MediaFailed(object sender, ExceptionRoutedEventArgs e)
		{
			ViewModel.HandleMediaFailed(e.ErrorException);
		}
	}
}