﻿using System.Collections.ObjectModel;
using System.Windows.Input;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class MessagesViewModel : ViewModelBase
	{
		public MessagesViewModel(IChatService chatService): base("Received")
		{
			ArgumentValidator.AssertNotNull(chatService, "chatService");
			chatService.MessageReceived 
				+= (sender, args) =>
			        {
						if (args == null)
						{
							return;
						}
						messageItems.Add(new MessageItem(args.Message));
			        	Feedback = "Message received.";
			        };

			refreshCommand = new DelegateCommand(
				obj =>
				{
					Feedback = "Refresh command executed.";
				});
		}

		ObservableCollection<MessageItem> messageItems
			= new ObservableCollection<MessageItem>();
				// For Screen shots.
				//			  	{
				//			  		new MessageItem("Hi from sample app!"),
				//			  		new MessageItem("It appears to be working...")
				//			  	};

		public ObservableCollection<MessageItem> MessageItems
		{
			get
			{
				return messageItems;
			}
			internal set
			{
				Assign("MessageItems", ref messageItems, value);
			}
		}

		string feedback;

		public string Feedback
		{
			get
			{
				return feedback;
			}
			private set
			{
				Assign("Feedback", ref feedback, value);
			}
		}

		readonly DelegateCommand refreshCommand;

		public ICommand RefreshCommand
		{
			get
			{
				return refreshCommand;
			}
		}
	}
}