﻿using System.Windows.Input;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class SendMessageViewModel : ViewModelBase
	{
		public SendMessageViewModel(IChatService chatService) : base("Send")
		{
			ArgumentValidator.AssertNotNull(chatService, "chatService");

			sendCommand = new DelegateCommand(
				obj =>
				{
					if (!string.IsNullOrEmpty(messageBody))
					{
						chatService.SendMessage(messageBody);
						MessageBody = null;
						Feedback = "Message sent";
					}
				});
		}

		string emailAddress = "John@example.com";

		public string EmailAddress
		{
			get
			{
				return emailAddress;
			}
			set
			{
				Assign("EmailAddress", ref emailAddress, value);
			}
		}

		string messageBody = "Sample message";

		public string MessageBody
		{
			get
			{
				return messageBody;
			}
			set
			{
				Assign("MessageBody", ref messageBody, value);
			}
		}

		readonly DelegateCommand sendCommand;

		public ICommand SendCommand
		{
			get
			{
				return sendCommand;
			}
		}

		string feedback;

		public string Feedback
		{
			get
			{
				return feedback;
			}
			private set
			{
				Assign("Feedback", ref feedback, value);
			}
		}
	}
}