﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Threading;

using DanielVaughan.WindowsPhone7Unleashed.Examples.BookshopServiceReference;

using System.Linq;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class PanoramaViewModel : ViewModelBase
	{
		public PanoramaViewModel()
		{
			BookshopServiceClient client = new BookshopServiceClient();
			client.GetProductsCompleted 
				+= (sender, args) =>
			        {
						if (args.Error != null)
						{
							throw args.Error;
						}
												
			            Products = args.Result;
			            FeaturedProduct = args.Result.FirstOrDefault();
			        };
			client.GetProductsAsync();
		}

		ObservableCollection<Product> products;

		public ObservableCollection<Product> Products
		{
			get
			{
				return products;
			}
			private set
			{
				Assign("Products", ref products, value);
			}
		}

		Product featuredProduct;

		public Product FeaturedProduct
		{
			get
			{
				return featuredProduct;
			}
			private set
			{
				Assign("FeaturedProduct", ref featuredProduct, value);
			}
		}
	}
}
