﻿using System;
using System.Data.Services.Client;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Threading;

using DanielVaughan.WindowsPhone7Unleashed.Ebay;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class EbayClient : IEbayClient
	{
		DataServiceCollection<Item> searchResult;

		public void SearchItemsAsync(string query, int beginIndex = 0, int maxItems = 0)
		{
			EBayData ebayData = new EBayData(new Uri("http://ebayodata.cloudapp.net/"));

			searchResult = new DataServiceCollection<Item>(ebayData);

			searchResult.LoadCompleted 
				+= (sender, args) =>
					{
						if (args.Error != null)
						{
							SearchItemsComplete.Raise(this, 
								new SearchItemsCompleteEventArgs(
									   null, query, args.Error));
							return;
						}
						SearchItemsComplete.Raise(this, 
							new SearchItemsCompleteEventArgs(searchResult, query));
					};

			string parameter = HttpUtility.UrlEncode(query);

			IQueryable<Item> serviceQuery 
				= ebayData.Items.AddQueryOption("search", parameter)
								.AddQueryOption("$skip", beginIndex)
								.AddQueryOption("$top", maxItems);

			//serviceQuery = from item in serviceQuery
			//			    where item.CurrentPrice > 100.0
			//			    select item;
			
			searchResult.LoadAsync(serviceQuery);
		}

		public event EventHandler<SearchItemsCompleteEventArgs> SearchItemsComplete;
	}
}
