﻿using System;
using System.Text.RegularExpressions;

namespace DanielVaughan.WindowsPhone7Unleashed.Ebay
{
	public partial class Item
	{
		public TimeSpan? TimeLeftCustom
		{
			get
			{
				return ConvertToTimeSpan(TimeLeft);
			}
		}

		TimeSpan? ConvertToTimeSpan(string timeLeft)
		{
			Regex regex = new Regex(@"P(?<Days>\d+)DT(?<Hours>\d+)H(?<Minutes>\d+)M(?<Seconds>\d+)S");
			Match match = regex.Match(timeLeft);
			if (match.Success)
			{
				string timeSpanString = string.Format("{0}.{1}:{2}:{3}",
					match.Groups["Days"].Value, 
					match.Groups["Hours"].Value, 
					match.Groups["Minutes"].Value, 
					match.Groups["Seconds"].Value);
				TimeSpan result;
				if (TimeSpan.TryParse(timeSpanString, out result))
				{
					return result;
				}
			}
			return null;
		}
	}
}
