﻿using System;
using System.Data.Linq.Mapping;

using DanielVaughan.ComponentModel;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	[Table]
	[InheritanceMapping(Code = 0, Type = typeof(SavingsAccount), IsDefault = true)]
	[InheritanceMapping(Code = 1, Type = typeof(CheckingAccount))]
	[InheritanceMapping(Code = 2, Type = typeof(FixedDepositAccount))]
	public class BankAccount : NotifyPropertyChangeBase
	{
		int id;

		[Column(
			IsPrimaryKey = true, 
			DbType = "INT IDENTITY NOT NULL", 
			IsDbGenerated = true, 
			UpdateCheck = UpdateCheck.Never)]
		public int Id
		{
			get
			{
				return id;
			}
			set
			{
				Assign("Id", ref id, value);
			}
		}
		
		int bankAccountTypeId;

		[Column(DbType = "Int NOT NULL", IsDiscriminator = true)]
		public int BankAccountTypeId
		{
			get
			{
				return bankAccountTypeId;
			}
			set
			{
				Assign("BankAccountTypeId", ref bankAccountTypeId, value);
			}
		}

		decimal balance;

		[Column]
		public decimal Balance
		{
			get
			{
				return balance;
			}
			set
			{
				Assign("Balance", ref balance, value);
			}
		}

		byte[] dataVersion;

		[Column(
			IsVersion = true, 
			IsDbGenerated = true, 
			UpdateCheck = UpdateCheck.Never)] /* database column is rowversion */
		 /*or use DbType = "timestamp"*/
		public byte[] DataVersion
		{
			get
			{
				return dataVersion;
			}
			set
			{
				Assign("DataVersion", ref dataVersion, value);
			}
		}
	}
}
