﻿using System;
using System.Data.Linq;
using System.Data.Linq.Mapping;

using DanielVaughan.ComponentModel;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	[Table]
	public class TimelineItem : NotifyPropertyChangeBase
	{
		string id;

		[Column(IsPrimaryKey = true)]
		public string Id
		{
			get
			{
				return id;
			}
			set
			{
				Assign("Id", ref id, value);
			}
		}

		string text;

		[Column(DbType = "NVarChar(140)")]
		public string Text
		{
			get
			{
				return text;
			}
			set
			{
				Assign("Text", ref text, value);
			}
		}

		DateTime? receivedTime;

		[Column]
		public DateTime? ReceivedTime
		{
			get
			{
				return receivedTime;
			}
			set
			{
				Assign("ReceivedTime", ref receivedTime, value);
			}
		}

		string twitterUserId;

		[Column(CanBeNull = false)]
		public string TwitterUserId
		{
			get
			{
				return twitterUserId;
			}
			set
			{
				Assign("TwitterUserId", ref twitterUserId, value);
			}
		}

		EntityRef<TwitterUser> user;

		[Association(Storage = "user", ThisKey = "TwitterUserId", IsForeignKey = true)]
		public TwitterUser TwitterUser
		{
			get
			{
				return user.Entity;
			}
			set
			{
				user.Entity = value;
			}
		}

//		string twitterUser2Id;
//
//		[Column]
//		public string TwitterUser2Id
//		{
//			get
//			{
//				return twitterUser2Id;
//			}
//			set
//			{
//				Assign("TwitterUser2Id", ref twitterUser2Id, value);
//			}
//		}
//
//		EntityRef<TwitterUser> user2;
//
//		[Association(Storage = "user2", ThisKey = "TwitterUser2Id", IsForeignKey = true, Name = "FK_TwitterUser2")]
//		public TwitterUser TwitterUser2
//		{
//			get
//			{
//				return user2.Entity;
//			}
//			set
//			{
//				user2.Entity = value;
//			}
//		}
	}
}