﻿using System;
using System.Data.Linq;
using System.Data.Linq.Mapping;

using DanielVaughan.ComponentModel;

using Microsoft.Phone.Data.Linq.Mapping;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	//[Table(Name = "SomethingElse")]
	[Table]
	[Index(Columns = "ScreenName")]
	public class TwitterUser : NotifyPropertyChangeBase
	{
		public TwitterUser()
		{
			timelineItems 
				= new EntitySet<TimelineItem>(AttachTimelineItem, DetachTimelineItems);
		}

		string id;

		[Column(IsPrimaryKey = true)]
		public string Id
		{
			get
			{
				return id;
			}
			set
			{
				Assign("Id", ref id, value);
			}
		}

		string screenName;

		[Column]
		public string ScreenName
		{
			get
			{
				return screenName;
			}
			set
			{
				Assign("ScreenName", ref screenName, value);
			}
		}

		string description;

		[Column]
		public string Description
		{
			get
			{
				return description;
			}
			set
			{
				Assign("Description", ref description, value);
			}
		}

		string imageUrl;

		[Column]
		public string ImageUrl
		{
			get
			{
				return imageUrl;
			}
			set
			{
				Assign("ImageUrl", ref imageUrl, value);
			}
		}

		readonly EntitySet<TimelineItem> timelineItems;

		[Association(
			Storage = "timelineItems", 
			OtherKey = "TwitterUserId")]
		public EntitySet<TimelineItem> TimelineItems
		{
			get
			{
				return timelineItems;
			}
			set
			{
				timelineItems.Assign(value);
			}
		}

//		readonly EntitySet<TimelineItem> timelineItems2;
//
//		[Association(
//			Storage = "timelineItems2",
//			OtherKey = "TwitterUserId")]
//		public EntitySet<TimelineItem> TimelineItems2
//		{
//			get
//			{
//				return timelineItems2;
//			}
//			set
//			{
//				timelineItems2.Assign(value);
//			}
//		}

		void AttachTimelineItem(TimelineItem entity)
		{
			OnPropertyChanging("TimelineItems", timelineItems, timelineItems);
			entity.TwitterUser = this;
			OnPropertyChanged("TimelineItems");
		}

		void DetachTimelineItems(TimelineItem entity)
		{
			OnPropertyChanging("TimelineItems", timelineItems, null);
			entity.TwitterUser = null;
			OnPropertyChanged("TimelineItems");
		}
	}
}