﻿#define UseIsoDatabase

using DanielVaughan.Data;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public class TwitterDatabaseUtility : DatabaseUtility
	{

#if UseIsoDatabase
		static string databaseFileName = "isostore:Twitter.sdf";

		public TwitterDatabaseUtility(string databaseFileName = null)
			: base(databaseFileName ?? TwitterDatabaseUtility.databaseFileName)
		{
			/* Intentionally left blank. */
		}
#else
		static string databaseFileName = "/DataDrivenApps/TwitterExample/Twitter.sdf";

		public TwitterDatabaseUtility(string databaseFileName = null)
			: base(databaseFileName ?? TwitterDatabaseUtility.databaseFileName, 
				LocalDatabaseMode.ReadOnly)
		{
			/* Intentionally left blank. */
		}
#endif
		
		public static string DefaultDatabaseFileName
		{
			get
			{
				return databaseFileName;
			}
			set
			{
				databaseFileName = value;
			}
		}

		public TwitterDataContext CreateContext()
		{
			TwitterDataContext result = new TwitterDataContext(ConnectionString);
			return result;
		}

		public void InitializeDatabase(bool wipe = false)
		{
			TwitterDataContext dataContext = new TwitterDataContext(ConnectionString);
			InitializeDatabase(dataContext, wipe);
		}
	}
}