﻿using System.Windows.Input;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public class TwitterSignInViewModel : ViewModelBase
	{
		public TwitterSignInViewModel()
		{
			signInCommand = new DelegateCommand(
				obj =>
				{
					if (!rememberPassword)
					{
						DeregisterStatefulProperty(ApplicationStateType.Persistent, () => Password);
					}
					Navigate("/TwitterTimeline/" + username);
				});
		}

		string username = "dbvaughan";

		[Stateful(ApplicationStateType.Persistent)]
		public string Username
		{
			get
			{
				return username;
			}
			set
			{
				Assign(() => Username, ref username, value);
			}
		}

		string password;

		[Stateful(ApplicationStateType.Persistent)]
		public string Password
		{
			get
			{
				return password;
			}
			set
			{
				Assign(() => Password, ref password, value);
			}
		}

		readonly DelegateCommand signInCommand;

		public ICommand SignInCommand
		{
			get
			{
				return signInCommand;
			}
		}

		bool rememberPassword = true;

		[Stateful(ApplicationStateType.Persistent)]
		public bool RememberPassword
		{
			get
			{
				return rememberPassword;
			}
			set
			{
				Assign(() => RememberPassword, ref rememberPassword, value);
			}
		}
	}
}
