﻿using System;
using System.Diagnostics;

using DanielVaughan.Shell;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public class LockScreenViewModel : ViewModelBase
	{
		public LockScreenViewModel() : base("lock screen settings")
		{
		    LockScreenManager manager = LockScreenManager.Instance;
		    
            if (!manager.UserPrompted)
            {
                bool allow = MessageService.AskYesNoQuestion(
                    "Is it OK to run under the phone's lock screen?");
                manager.RunningUnderLockScreenEnabled = allow;
                manager.UserPrompted = true;
            }

		    manager.PropertyChanged 
                += (o, args) =>
		        {
		            if (args.PropertyName == "RunningUnderLockScreen")
		            {
		                Debug.WriteLine("RunningUnderLockScreen: " 
                                            + manager.RunningUnderLockScreen);
		            }
		        };
		}

        public bool RunningUnderLockScreenEnabled
	    {
	        get
	        {
	            return LockScreenManager.Instance.RunningUnderLockScreenEnabled;
	        }
	        set
	        {
                LockScreenManager.Instance.RunningUnderLockScreenEnabled = value;
	        }
	    }
	}
}
