﻿using System;
using System.Device.Location;
using System.Windows.Input;

using Microsoft.Phone.Tasks;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class AddressChooserTaskViewModel : ViewModelBase
	{
        readonly AddressChooserTask addressChooserTask = new AddressChooserTask();

        public AddressChooserTaskViewModel() : base("address chooser")
        {
            addressChooserTask.Completed += HandleTaskCompleted;
            chooseAddressCommand = new DelegateCommand(arg => addressChooserTask.Show());
        }

	    void HandleTaskCompleted(object sender, AddressResult e)
	    {
            if (e.Error != null)
            {
                MessageService.ShowError("Unable to retrieve address");
            }

            if (e.TaskResult != TaskResult.OK)
            {
                return;
            }
            
	        DisplayName = e.DisplayName;
	        Address = e.Address;
	    }

	    readonly DelegateCommand chooseAddressCommand;

		public ICommand ChooseAddressCommand
		{
			get
			{
				return chooseAddressCommand;
			}
		}

	    string displayName = "Daniel Vaughan";

	    public string DisplayName
	    {
	        get
	        {
	            return displayName;
	        }
	        private set
	        {
	            Assign(() => DisplayName, ref displayName, value);
	        }
	    }

	    string address = "Geneva Switzerland";

	    public string Address
	    {
	        get
	        {
	            return address;
	        }
	        private set
	        {
	            Assign(() => Address, ref address, value);
	        }
	    }
	}
}
