﻿using System.Device.Location;
using System.Windows.Input;

using Microsoft.Phone.Tasks;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class BingMapsDirectionsTaskViewModel : ViewModelBase
	{
        readonly BingMapsDirectionsTask bingMapsDirectionsTask = new BingMapsDirectionsTask();

        public BingMapsDirectionsTaskViewModel() : base("get directions")
        {
            searchCommand = new DelegateCommand(arg => ShowTask());
        }

	    void ShowTask()
	    {
            //GeoCoordinate geoCoordinate = new GeoCoordinate(46.25829, 6.20966);
	        bingMapsDirectionsTask.Start = new LabeledMapLocation(startLocation, null);
	        bingMapsDirectionsTask.End = new LabeledMapLocation(endLocation, null);
            bingMapsDirectionsTask.Show();  
	    }

	    readonly DelegateCommand searchCommand;

		public ICommand SearchCommand
		{
			get
			{
				return searchCommand;
			}
		}

        string startLocation = "paris";

        public string StartLocation
	    {
	        get
	        {
	            return startLocation;
	        }
	        set
	        {
	            Assign(() => StartLocation, ref startLocation, value);
	        }
	    }

	    string endLocation = "geneva";

	    public string EndLocation
	    {
	        get
	        {
	            return endLocation;
	        }
	        set
	        {
	            Assign(() => EndLocation, ref endLocation, value);
	        }
	    }
	}
}
