﻿using System.Windows.Input;
using System.Windows.Media.Imaging;

using Microsoft.Phone.Tasks;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class CameraCaptureViewModel : ViewModelBase
	{
		readonly CameraCaptureTask cameraCaptureTask = new CameraCaptureTask();

		public CameraCaptureViewModel() : base("capture image")
		{
			cameraCaptureTask.Completed += HandleCameraCaptureTaskCompleted;	
			captureCommand = new DelegateCommand(obj => cameraCaptureTask.Show());
		}

		void HandleCameraCaptureTaskCompleted(object sender, PhotoResult e)
		{
			if (e.TaskResult == TaskResult.OK)
			{
				BitmapImage bitmapImage = new BitmapImage();
				bitmapImage.SetSource(e.ChosenPhoto);
				CapturedImage = bitmapImage;
			}
            else if (e.Error != null)
            {
                MessageService.ShowError("An error occurred. " + e.ToString());
            }
            else if (e.TaskResult == TaskResult.Cancel)
            {
                /* Cancelled. */
            }
		}

		readonly DelegateCommand captureCommand;

		public ICommand CaptureCommand
		{
			get
			{
				return captureCommand;
			}
		}

		BitmapImage capturedImage;

		public BitmapImage CapturedImage
		{
			get
			{
				return capturedImage;
			}
			private set
			{
				Assign(() => CapturedImage, ref capturedImage, value);
			}
		}
	}
}
