﻿using System.Collections.Generic;
using System.Windows.Input;

using Microsoft.Phone.Tasks;

using System.Linq;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class ConnectionSettingsTaskViewModel : ViewModelBase
	{
        public ConnectionSettingsTaskViewModel() : base("connection settings")
        {
            showSettingsCommand = new DelegateCommand(arg => ShowTask());
        }

	    void ShowTask()
	    {
            ConnectionSettingsTask task = new ConnectionSettingsTask();
	        task.ConnectionSettingsType = ConnectionSettingsType;
            task.Show();  
	    }

	    readonly DelegateCommand showSettingsCommand;

		public ICommand ShowSettingsCommand
		{
			get
			{
				return showSettingsCommand;
			}
		}

	    static readonly IEnumerable<ConnectionSettingsType> connectionSettingsTypes 
            = EnumUtility.CreateEnumValueList<ConnectionSettingsType>();

	    public IEnumerable<ConnectionSettingsType> ConnectionSettingsTypes
	    {
	        get
	        {
	            return connectionSettingsTypes;
	        }
	    }

	    ConnectionSettingsType connectionSettingsType = connectionSettingsTypes.FirstOrDefault();

	    public ConnectionSettingsType ConnectionSettingsType
	    {
	        get
	        {
	            return connectionSettingsType;
	        }
	        set
	        {
	            Assign(() => ConnectionSettingsType, ref connectionSettingsType, value);
	        }
	    }
	}
}
