﻿using System.Windows.Input;

using Microsoft.Phone.Tasks;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class GameInviteTaskViewModel : ViewModelBase
	{
        readonly GameInviteTask gameInviteTask = new GameInviteTask();

        public GameInviteTaskViewModel() : base("game invite")
        {
            gameInviteTask.Completed += HandleTaskCompleted;
            inviteCommand = new DelegateCommand(arg => SaveRingtone());
        }

	    void HandleTaskCompleted(object sender, TaskEventArgs e)
	    {
            if (e.Error != null)
            {
                MessageService.ShowError("An error occurred.");
                return;
            }

            if (e.TaskResult == TaskResult.OK)
            {
                MessageService.ShowMessage("Invitation sent.");
            }
            else if (e.TaskResult == TaskResult.Cancel)
            {
                MessageService.ShowMessage("Invitation cancelled.");
            }
	    }

	    void SaveRingtone()
	    {
	        gameInviteTask.SessionId = "<session id>";
	        gameInviteTask.Show();
	    }

	    readonly DelegateCommand inviteCommand;

		public ICommand InviteCommand
		{
			get
			{
				return inviteCommand;
			}
		}
	}
}
