﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows.Input;

using Microsoft.Phone.Tasks;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class MediaPlayerLauncherViewModel : ViewModelBase
	{
		public MediaPlayerLauncherViewModel() : base("Media Player Launcher")
		{
			launchCommand = new DelegateCommand(
				delegate
					{
						MediaPlayerLauncher mediaPlayerLauncher
							= new MediaPlayerLauncher
								{
								  	//Media = new Uri("http://www.calciumsdk.net/CalciumSdkVideos/CalciumGettingStarted.wmv", UriKind.Absolute),
								  	Media = new Uri("LaunchersAndChoosers/Video.wmv", UriKind.Relative),
								  	Location = MediaLocationType.Install,
								};

						if (playbackControls.Count > 0)
						{
							mediaPlayerLauncher.Controls 
								= playbackControls.Aggregate((a, b) => a | b);
						}

						mediaPlayerLauncher.Show();
					});
		}

		readonly List<MediaPlaybackControls> mediaPlaybackControls
			= new List<MediaPlaybackControls>
					{
						MediaPlaybackControls.FastForward, 
						MediaPlaybackControls.Pause, 
						MediaPlaybackControls.Rewind, 
						/* Not used by Media Player. */
						//MediaPlaybackControls.Skip, 
						//MediaPlaybackControls.Stop
					};

		public IEnumerable<MediaPlaybackControls> AvailablePlaybackControls
		{
			get
			{
				return mediaPlaybackControls;
			}
		}

		readonly ObservableCollection<MediaPlaybackControls> playbackControls 
			= new ObservableCollection<MediaPlaybackControls>();

		public ObservableCollection<MediaPlaybackControls> PlaybackControls
		{
			get
			{
				return playbackControls;
			}
		}

		readonly DelegateCommand launchCommand;

		public ICommand LaunchCommand
		{
			get
			{
				return launchCommand;
			}
		}

		string message;

		public string Message
		{
			get
			{
				return message;
			}
			set
			{
				Assign(() => Message, ref message, value);
			}
		}
	}
}
