﻿using System.Windows.Input;

using Microsoft.Phone.Tasks;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class SaveContactTaskViewModel : ViewModelBase
	{
        readonly SaveContactTask saveContactTask = new SaveContactTask();

        public SaveContactTaskViewModel() : base("save contact")
        {
            saveContactTask.Completed += HandleTaskCompleted;
            saveCommand = new DelegateCommand(arg => SaveContact());
        }

	    void SaveContact()
	    {
	        saveContactTask.FirstName = firstName;
	        saveContactTask.LastName = lastName;
	        saveContactTask.PersonalEmail = emailAddress;
	        saveContactTask.Website = website;
	        saveContactTask.Show();
	    }

	    void HandleTaskCompleted(object sender, SaveContactResult e)
	    {
	        if (e.Error != null)
	        {
	            MessageService.ShowError("Unable to retrieve address");
	            return;
	        }

            if (e.TaskResult == TaskResult.OK)
            {
                MessageService.ShowMessage("Contact saved.");
            }
	    }

	    readonly DelegateCommand saveCommand;

		public ICommand SaveCommand
		{
			get
			{
				return saveCommand;
			}
		}

	    string firstName = "Alan";

	    public string FirstName
	    {
	        get
	        {
	            return firstName;
	        }
	        set
	        {
	            Assign(() => FirstName, ref firstName, value);
	        }
	    }

	    string lastName = "Turing";

	    public string LastName
	    {
	        get
	        {
	            return lastName;
	        }
	        set
	        {
	            Assign(() => LastName, ref lastName, value);
	        }
	    }

	    string emailAddress = "alan.turing@example.com";

	    public string EmailAddress
	    {
	        get
	        {
	            return emailAddress;
	        }
	        set
	        {
	            Assign(() => EmailAddress, ref emailAddress, value);
	        }
	    }

        string website = "http://en.wikipedia.org/wiki/Alan_Turing";

	    public string Website
	    {
	        get
	        {
	            return website;
	        }
	        set
	        {
	            Assign(() => Website, ref website, value);
	        }
	    }
	}
}
