﻿using System.Diagnostics;
using System.Windows.Input;

using Microsoft.Phone.Tasks;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class SaveEmailAddressViewModel : ViewModelBase
	{
        readonly SaveEmailAddressTask saveEmailAddressTask 
                                            = new SaveEmailAddressTask();

		public SaveEmailAddressViewModel() : base("Save Email Address")
		{
			saveEmailAddressTask.Completed += HandleSaveEmailAddressTaskCompleted;	

			saveCommand = new DelegateCommand(
				delegate
					{
						Message = string.Empty;
						saveEmailAddressTask.Email = emailAddress;
						saveEmailAddressTask.Show();
					});
		}

		void HandleSaveEmailAddressTaskCompleted(object sender, TaskEventArgs e)
		{
			if (e.Error != null)
			{
				Message = "Unable to save the email address. " + e.Error;
				return;
			}

			if (e.TaskResult == TaskResult.OK)
			{
				Message = "Email address saved";
			}
			else if (e.TaskResult == TaskResult.Cancel)
			{
				Message = "Cancelled";
			}
		}

		string emailAddress;

		public string EmailAddress
		{
			get
			{
				return emailAddress;
			}
			set
			{
				Assign(() => EmailAddress, ref emailAddress, value);
			}
		}

		readonly DelegateCommand saveCommand;

		public ICommand SaveCommand
		{
			get
			{
				return saveCommand;
			}
		}

		string message;

		public string Message
		{
			get
			{
				return message;
			}
			set
			{
				Assign("Message", ref message, value);
			}
		}

//		readonly SaveEmailAddressTask saveEmailAddressTask
//			= new SaveEmailAddressTask();
//
//		public SomeViewModel()
//		{
//			/* 2. */
//			saveEmailAddressTask.Completed += HandleSaveEmailAddressTaskCompleted;
//			/* 4. */
//			Debug.WriteLine("Constructor.");
//		}
//
//		public void ShowLauncher()
//		{
//			/* 1. */
//			saveEmailAddressTask.Show();
//		}
//
//		void HandleSaveEmailAddressTaskCompleted(object sender, TaskEventArgs e)
//		{
//			/* 3. */
//			Debug.WriteLine("Task Completed.");
//		}
	}
}
