﻿using System.Windows.Input;

using Microsoft.Phone.Tasks;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class SavePhoneNumberViewModel : ViewModelBase
	{
		public SavePhoneNumberViewModel() : base("Save Phone Number")
		{
			SavePhoneNumberTask savePhoneNumberTask = new SavePhoneNumberTask();
			savePhoneNumberTask.Completed += HandleSavePhoneNumberTaskCompleted;	

			saveCommand = new DelegateCommand(
				delegate
					{
						Message = string.Empty;
						savePhoneNumberTask.PhoneNumber = phoneNumber;
						savePhoneNumberTask.Show();
					});
		}

		void HandleSavePhoneNumberTaskCompleted(object sender, TaskEventArgs e)
		{
			if (e.Error != null)
			{
				Message = "Unable to save the phone number. " + e.Error;
				return;
			}

			if (e.TaskResult == TaskResult.OK)
			{
				Message = "Phone number saved";
			}
			else if (e.TaskResult == TaskResult.Cancel)
			{
				Message = "Cancelled";
			}
		}

		string phoneNumber;

		public string PhoneNumber
		{
			get
			{
				return phoneNumber;
			}
			set
			{
				Assign(() => PhoneNumber, ref phoneNumber, value);
			}
		}

		readonly DelegateCommand saveCommand;

		public ICommand SaveCommand
		{
			get
			{
				return saveCommand;
			}
		}

		string message;

		public string Message
		{
			get
			{
				return message;
			}
			set
			{
				Assign("Message", ref message, value);
			}
		}
	}
}
