﻿using System;
using System.Windows.Input;

using Microsoft.Phone.Tasks;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public class SaveRingtoneTaskViewModel : ViewModelBase
	{
        readonly SaveRingtoneTask saveRingtoneTask = new SaveRingtoneTask();

        public SaveRingtoneTaskViewModel() : base("save ringtone")
        {
            saveRingtoneTask.Completed += HandleTaskCompleted;
            saveCommand = new DelegateCommand(arg => SaveRingtone());
        }

	    void HandleTaskCompleted(object sender, TaskEventArgs e)
	    {
            if (e.Error != null)
            {
                MessageService.ShowError("Unable to save ringtone.");
                return;
            }

            if (e.TaskResult == TaskResult.OK)
            {
                MessageService.ShowMessage("Ringtone saved.");
            }
	    }

	    void SaveRingtone()
	    {
	        saveRingtoneTask.DisplayName = displayName;
	        saveRingtoneTask.IsShareable = shareable;
            saveRingtoneTask.Source = new Uri("appdata:/AudioFiles/Audio01.wma");
            //saveRingtoneTask.Source = new Uri("isostore:/AudioFiles/Audio01.wma");
	        saveRingtoneTask.Show();
	    }

	    readonly DelegateCommand saveCommand;

		public ICommand SaveCommand
		{
			get
			{
				return saveCommand;
			}
		}

        string displayName = string.Format("Audio01-{0:yyyy-MM-dd_hh-mm-ss-tt}.wma", DateTime.Now);

	    public string DisplayName
	    {
	        get
	        {
	            return displayName;
	        }
	        set
	        {
	            Assign(() => DisplayName, ref displayName, value);
	        }
	    }

	    bool shareable;

	    public bool Shareable
	    {
	        get
	        {
	            return shareable;
	        }
	        set
	        {
	            Assign(() => Shareable, ref shareable, value);
	        }
	    }
	}
}
