﻿using System;
using System.Diagnostics;
using System.IO;
using System.Runtime.Serialization.Json;
using System.Windows;

using DanielVaughan.WindowsPhone7Unleashed.LauncherModel;
using DanielVaughan.WindowsPhone7Unleashed.Launchers;

using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public partial class SendEmailView : PhoneApplicationPage
	{
		readonly SendEmailViewModel viewModel = new SendEmailViewModel(
			() => new ChooserAdapter<EmailResult>(new EmailAddressChooserTask()),
			() => new EmailComposeTaskAdapter());

		public SendEmailView()
		{
			InitializeComponent();
			DataContext = viewModel;
		}

		void Button_SelectTo_Tap(object sender, System.Windows.Input.GestureEventArgs e)
		{
			AssignAddress(obj => { viewModel.To = obj; });
		}

		void Button_SelectCc_Tap(object sender, System.Windows.Input.GestureEventArgs e)
		{
			AssignAddress(obj => { viewModel.Cc = obj; });
		}

		void AssignAddress(Action<string> assignAction)
		{
			EmailAddressChooserTask emailAddressChooserTask 
				= new EmailAddressChooserTask();

			emailAddressChooserTask.Completed += new EventHandler<EmailResult>(
				(o, args) =>
				{
					if (args.Error != null)
					{
						return;
					}
					if (args.TaskResult == TaskResult.OK)
					{
						assignAction(args.Email);
					}
					else if (args.TaskResult == TaskResult.None)
					{
						assignAction(string.Empty);
					}
				});
			emailAddressChooserTask.Show();
		}

		protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
		{
			//PhoneApplicationService.Current.State["blah"] = viewModel;
			byte[] contentBytes;
//			var serializer = new DataContractJsonSerializer(viewModel.GetType());
//
//			using (MemoryStream stream = new MemoryStream())
//			{
//				serializer.WriteObject(stream, viewModel);
//				contentBytes = stream.ToArray();
//			}
//			PhoneApplicationService.Current.State["blah"] = contentBytes;
//			base.OnNavigatedFrom(e);
		}

		protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
		{
//			object blah;
//			PhoneApplicationService.Current.State.TryGetValue("blah", out blah);
//			if (blah != null)
//			{
//				var bodyBytes = (byte[])blah;
//				int lengthWithoutNulls = bodyBytes.Length;
//				for (int i = bodyBytes.Length - 1; i >= 0 && bodyBytes[i] == '\0';
//														i--, lengthWithoutNulls--)
//				{
//					/* Intentionally left blank. */
//				}
//
//				byte[] cleanedBytes = new byte[lengthWithoutNulls];
//				Array.Copy(bodyBytes, cleanedBytes, lengthWithoutNulls);
//
//				DataContractJsonSerializer serializer
//					= new DataContractJsonSerializer(typeof(SendEmailViewModel));
//
//				using (MemoryStream stream = new MemoryStream(cleanedBytes))
//				{
//					var jjj = (SendEmailViewModel)serializer.ReadObject(stream);
//				}
//			}
			base.OnNavigatedTo(e);
		}
	}
	
}

