﻿using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Windows;
using System.Windows.Navigation;

using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Microsoft.Phone.Tasks;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples.Navigation
{
	public partial class ProductDetailsView : PhoneApplicationPage
	{
		public ProductDetailsView()
		{
			InitializeComponent();
			
			DataContext = new ProductDetailsViewModel(
				PhoneApplicationService.Current.State);
			BackKeyPress += Page_OnBackKeyPress;
		}

		void Page_OnBackKeyPress(object sender, CancelEventArgs e)
		{
			Debug.WriteLine("ProductDetailsView OnBackKeyPress");
			//e.Cancel = true;
		}

		ProductDetailsViewModel ViewModel
		{
			get
			{
				return (ProductDetailsViewModel)DataContext;
			}
		}

		protected override void OnNavigatedTo(NavigationEventArgs e)
		{
			// Other navigation examples:
			//NavigationService.Navigate(new Uri("/DanielVaughan.WindowsPhone7Unleashed.Examples.Silverlight;component/Navigation/ProductsView.xaml", UriKind.Relative));
			//NavigationService.Navigate(new Uri("/DanielVaughan.WindowsPhone7Unleashed.Examples.Silverlight;component/Navigation/ProductsView.xaml", UriKind.Relative));NavigationService.Navigate(new Uri("/DanielVaughan.WindowsPhone7Unleashed.Examples.Silverlight;component/Navigation/ProductsView.xaml", UriKind.Relative));
			//return;
			//NavigationService.Navigate(new Uri("/Navigation/ProductsView.xaml", UriKind.Relative));
			//return;
			Debug.WriteLine("ProductDetailsView OnNavigatedTo");
			base.OnNavigatedTo(e);
			string productIdString = NavigationContext.QueryString["productId"];
			int productId = int.Parse(productIdString);
			ViewModel.LoadProduct(productId);
		}

		protected override void OnNavigatedFrom(NavigationEventArgs e)
		{
			Debug.WriteLine("ProductDetailsView OnNavigatedFrom");
			ViewModel.SaveTransientState();
			base.OnNavigatedFrom(e);
		}

		protected override void OnNavigatingFrom(NavigatingCancelEventArgs e)
		{
			Debug.WriteLine("ProductDetailsView OnNavigatingFrom");
			/* Do not attempt to cancel a navigation when the hardware back button 
			 * has been pressed.
			 * If you must, use the BackKeyPressed event instead. */
			//			if (e.NavigationMode == NavigationMode.Back)
			//			{
			//				Don't do this!
			//				e.Cancel = true;
			//			}
			base.OnNavigatingFrom(e);
		}

//		protected override void OnNavigatingFrom(
//			System.Windows.Navigation.NavigatingCancelEventArgs e)
//		{
//			Debug.WriteLine("ProductDetailsView OnNavigatingFrom");
//			base.OnNavigatingFrom(e);
//			MessageBoxResult boxResult = MessageBox.Show(
//				"Leave this page?", "Question", MessageBoxButton.OKCancel);
//			if (boxResult != MessageBoxResult.OK)
//			{
//				e.Cancel = true;
//			}
//		}

//		protected override void OnNavigatingFrom(NavigatingCancelEventArgs e)
//		{
//			if (e.Uri.ToString().Contains("WebBrowser"))
//			{
//				e.Cancel = true;
//				/* Perform the redirect on the UI thread. */
//				Dispatcher.BeginInvoke(() => NavigationService.Navigate(
//					new Uri("/MainPage.xaml", UriKind.Relative)));
//			}
//			
//			base.OnNavigatingFrom(e);
//		}

		void Button_ExternalLink_Tap(object sender, System.Windows.Input.GestureEventArgs e)
		{
			FrameworkElement button = sender as FrameworkElement;
			if (button == null || button.Tag == null)
			{
				return;
			}
			WebBrowserTask task = new WebBrowserTask
			{
				URL = button.Tag.ToString()
			};
			task.Show();
		}
	}
}