﻿using System.Diagnostics;
using System.Windows;

using Microsoft.Phone.Controls;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public partial class OrientationView : PhoneApplicationPage
	{
		public OrientationView()
		{
			InitializeComponent();

			OrientationChanged += (sender, args) => VisualStateManager.GoToState(
				this, args.Orientation.ToString(), true);
			//((AnimateOrientationChangesFrame)Application.Current.RootVisual).AnimationEnabled = false;
		}

		protected override void OnOrientationChanged(OrientationChangedEventArgs e)
		{
			Debug.WriteLine("Orientation changed to " + e.Orientation.ToString("G"));
			if (e.Orientation.IsPortrait())
			{
				Debug.WriteLine("Portrait orientation.");
			}
			if (e.Orientation.IsLandscape())
			{
				Debug.WriteLine("Landscape orientation.");
			}

			Dispatcher.BeginInvoke(
				delegate
					{
						Debug.WriteLine(string.Format(
							"Using dispatcher: ActualWidth: {0}, ActualHeight: {1}", 
							ActualWidth, ActualHeight));
					});

			Debug.WriteLine(string.Format(
				"Without dispatcher: ActualWidth: {0}, ActualHeight: {1}", 
				ActualWidth, ActualHeight));

			base.OnOrientationChanged(e);
		}

        void Button_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            switch (SupportedOrientations)
            {
                case SupportedPageOrientation.Landscape:
                    SupportedOrientations = SupportedPageOrientation.Portrait;
                    break;
                case SupportedPageOrientation.Portrait:
                    SupportedOrientations = SupportedPageOrientation.PortraitOrLandscape;
                    break;
                default:
                    SupportedOrientations = SupportedPageOrientation.Landscape;
                    break;
            }
            /* Setting the dependency property directly has no effect. */
            //SetValue(OrientationProperty, PageOrientation.LandscapeRight);
        }
	}
}