using System;
using System.Windows;
using System.Windows.Media.Imaging;

using Microsoft.Phone.Controls;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public partial class PushNotificationView : PhoneApplicationPage
	{
		public PushNotificationView()
		{
			InitializeComponent();
			PushNotificationViewModel viewModel = new PushNotificationViewModel();
			DataContext = viewModel;
			viewModel.PropertyChanged += viewModel_PropertyChanged;

		}

		void viewModel_PropertyChanged(object sender, 
			System.ComponentModel.PropertyChangedEventArgs e)
		{
			if (e.PropertyName == "StockPriceDirection")
			{
				string url;
				switch (ViewModel.StockPriceDirection)
				{
					case StockPriceDirection.Down:
						url = "Images/StockDown.png";
						break;
					case StockPriceDirection.Up:
						url = "Images/StockUp.png";
						break;
					default:
						url = "Images/StockNone.png";
						break;
				}
				Image_StockQuote.Source = new BitmapImage(
					new Uri(url, UriKind.Relative));
			}
		}

		public PushNotificationViewModel ViewModel
		{
			get
			{
				return (PushNotificationViewModel)DataContext;
			}
		}

		void Button_Register_Tap(object sender, System.Windows.Input.GestureEventArgs e)
		{
			/* For simplicity we call present a dialog from the view. 
			 * Ordinarily we would rely on some like an Message Service, 
			 * which could present a dialog from the viewmodel 
			 * in a UI agnostic manner. */
			MessageBoxResult messageBoxResult = MessageBox.Show(
				"Is it ok to display notifications?",
				"Question",
				MessageBoxButton.OKCancel);

			if (messageBoxResult != MessageBoxResult.OK)
			{
				return;
			}
			ViewModel.RegisterForPushNotification();
		}

		void Button_Unregister_Tap(object sender, System.Windows.Input.GestureEventArgs e)
		{
			ViewModel.UnregisterForPushNotification();
		}

	}
}