﻿using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Navigation;

using DanielVaughan.Data;
using DanielVaughan.Devices.Sensors;

using Microsoft.Phone.Controls;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples.Sensors
{
	public partial class AccelerometerView : PhoneApplicationPage
	{
		public AccelerometerView()
		{
			InitializeComponent();

			DataContext = new AccelerometerViewModel(new EnhancedAccelerometer(new IsolatedStorageUtility()));
		}

		AccelerometerViewModel ViewModel
		{
			get
			{
				return (AccelerometerViewModel)DataContext;
			}
		}

		protected override void OnNavigatedTo(NavigationEventArgs e)
		{
			base.OnNavigatedTo(e);
			ViewModel.StartCommand.Execute(null);
		}

		protected override void OnNavigatedFrom(NavigationEventArgs e)
		{
			base.OnNavigatedFrom(e);
			ViewModel.StopCommand.Execute(null);
		}
	}

	public class SquashConverter : IValueConverter
	{
		public object Convert(
			object value, Type targetType, object parameter, CultureInfo culture)
		{
			double d = (double)value + 1;
			double result = Math.Max(0, Math.Min(2, d));
			return result;
		}

		public object ConvertBack(
			object value, Type targetType, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException("Only supports a one way binding");
		}
	}
}