﻿using System.IO;
using System.Linq;
using System.Windows.Media.Imaging;

using Microsoft.Xna.Framework.Media;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples.Sensors
{
	public class MediaLibraryImageViewModel: ViewModelBase
	{
		public MediaLibraryImageViewModel() : base("view image")
		{
			loadImageCommand = new DelegateCommand<string>(LoadImage);
		}

		void LoadImage(string name)
		{
			MediaLibrary mediaLibrary = new MediaLibrary();
			Picture picture = mediaLibrary.SavedPictures.Where(
												x => x.Name == name).FirstOrDefault();
			if (picture == null)
			{
				MessageService.ShowError(string.Format("The picture {0} was not found.", name));
				return;
			}

			BitmapImage bitmapImage;
			using (Stream stream = picture.GetImage())
			{
				bitmapImage = new BitmapImage();
				bitmapImage.SetSource(stream);
			}

			Image = bitmapImage;
			Title = name;
		}

		BitmapImage image;

		public BitmapImage Image
		{
			get
			{
				return image;
			}
			private set
			{
				Assign(() => Image, ref image, value);
			}
		}

		readonly DelegateCommand<string> loadImageCommand;

		public DelegateCommand<string> LoadImageCommand
		{
			get
			{
				return loadImageCommand;
			}
		}
	}
}
