﻿using System;
using System.ComponentModel;
using System.IO;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;

using Microsoft.Devices;
using Microsoft.Phone.Controls;
using Microsoft.Xna.Framework.Media;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples.Sensors
{
	public partial class PhotoCameraView : PhoneApplicationPage
	{
		readonly PhotoCameraViewModel viewModel = new PhotoCameraViewModel();

		public PhotoCameraView()
		{
			InitializeComponent();

			DataContext = viewModel;
		}

		PhotoCameraViewModel ViewModel
		{
			get
			{
				return (PhotoCameraViewModel)DataContext;
			}
		}

		protected override void OnNavigatedTo(NavigationEventArgs e)
		{
			ViewModel.Start();
			videoBrush_Preview.SetSource(ViewModel.Camera);
			base.OnNavigatedTo(e);
		}

		protected override void OnNavigatedFrom(NavigationEventArgs e)
		{
			ViewModel.Stop();
			base.OnNavigatedFrom(e);
		}

		//		protected override void OnBackKeyPress(CancelEventArgs e)
		//		{
		//			ScreenCaptureUtility.CaptureImageToMediaLibrary(this);
		//			e.Cancel = true;
		//			base.OnBackKeyPress(e);
		//		}
	}
}