﻿using System;
using System.Collections.Generic;

using Microsoft.Phone.Controls;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples.ControlExamples
{
	public class AutoCompleteBoxViewModel : ViewModelBase
	{
		public AutoCompleteBoxViewModel() : base("AutoCompleteBox")
		{

		}

		public void Populate(string text, Action completeAction)
		{
			Suggestions = new List<string>
			              	{
			              		"Daniel", "Sacha", "Marlon", "Pete", 
								"Josh", "Jaime", "Laurent", "Katka"
			              	};
			if (completeAction != null)
			{
				completeAction();
			}
		}

		IEnumerable<string> suggestions = new List<string>
			                      		{
			                      			"Prague", 
											"Geneva", 
											"Canberra",
											"London", 
											"Palma", 
											"Paris", 
											"New York",
											"Los Angeles"
			                      		};

		public IEnumerable<string> Suggestions
		{
			get
			{
				return suggestions;
			}
			private set
			{
				Assign(() => Suggestions, ref suggestions, value);
			}
		}

		readonly List<AutoCompleteFilterMode> filterModes 
			= new List<AutoCompleteFilterMode>
		            {
		                AutoCompleteFilterMode.Contains,
						AutoCompleteFilterMode.ContainsCaseSensitive,
						AutoCompleteFilterMode.ContainsOrdinal,
						AutoCompleteFilterMode.ContainsOrdinalCaseSensitive,
						AutoCompleteFilterMode.Custom,
						AutoCompleteFilterMode.Equals,
						AutoCompleteFilterMode.EqualsCaseSensitive,
						AutoCompleteFilterMode.EqualsOrdinal,
						AutoCompleteFilterMode.EqualsOrdinalCaseSensitive,
						AutoCompleteFilterMode.None,
						AutoCompleteFilterMode.StartsWith,
						AutoCompleteFilterMode.StartsWithCaseSensitive,
						AutoCompleteFilterMode.StartsWithOrdinal,
						AutoCompleteFilterMode.StartsWithOrdinalCaseSensitive,
		            };

		public IEnumerable<AutoCompleteFilterMode> FilterModes
		{
			get
			{
				return filterModes;
			}
		}

		AutoCompleteFilterMode filterMode;

		public AutoCompleteFilterMode FilterMode
		{
			get
			{
				return filterMode;
			}
			set
			{
				Assign(() => FilterMode, ref filterMode, value);
			}
		}

		AutoCompleteFilterPredicate<object> itemFilter = FilterOnLastLetter;

		public AutoCompleteFilterPredicate<object> ItemFilter
		{
			get
			{
				return itemFilter;
			}
			private set
			{
				Assign(() => ItemFilter, ref itemFilter, value);
			}
		}

		static bool FilterOnLastLetter(string enteredText, object suggestionItem)
		{
			if (suggestionItem != null 
				&& suggestionItem.ToString().ToLower().EndsWith(enteredText))
			{
				return true;
			}

			return false;
		}

	}

}
