﻿using System;
using System.Collections.Generic;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples.ControlExamples
{
	public class AutoCompleteBoxTemplatedViewModel : ViewModelBase
	{
		IEnumerable<SuggestionItem> suggestions = new List<SuggestionItem>
			{
				new SuggestionItem("Prague", "Capital of the Czech Republic."),
			    new SuggestionItem("Geneva", "Swiss city."),
				new SuggestionItem("Canberra", "Capital of Australia."),
				new SuggestionItem("London", "Capital of the England."),
				new SuggestionItem("Palma", "Major city of Mallorca."),
				new SuggestionItem("Paris", "Capital of France."),
				new SuggestionItem("New York", "Most populous city in the USA."),
				new SuggestionItem("Los Angeles", "Most populous city in California.")
			};

		public IEnumerable<SuggestionItem> Suggestions
		{
			get
			{
				return suggestions;
			}
			private set
			{
				Assign(() => Suggestions, ref suggestions, value);
			}
		}
	}

	public class SuggestionItem
	{
		public string Name { get; private set; }
		public string Description { get; private set; }

		public SuggestionItem(string name, string description)
		{
			Name = name;
			Description = description;
		}
	}
}
