﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows.Input;

using DanielVaughan.Services;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples.ControlExamples
{
	public class ContextMenuViewModel : ViewModelBase
	{
		public ContextMenuViewModel()
		{
			IEnumerable<string> temp = from int i in Enumerable.Range(1, 5) select "Item " + i;
			foreach (var itemName in temp)
			{
				items.Add(itemName);
			}

			deleteCommand = new DelegateCommand<string>(
				itemName => items.Remove(itemName));

			showMessageCommand = new DelegateCommand(
				parameter =>
				{
					var messageService = Dependency.Resolve<IMessageService>();
					messageService.ShowMessage(parameter + " clicked!");
				});
		}

		readonly ObservableCollection<string> items = new ObservableCollection<string>();

		public IEnumerable<string> Items
		{
			get
			{
				return items;
			}
		}

		readonly DelegateCommand<string> deleteCommand;

		public ICommand DeleteCommand
		{
			get
			{
				return deleteCommand;
			}
		}

		readonly DelegateCommand showMessageCommand;

		public ICommand ShowMessageCommand
		{
			get
			{
				return showMessageCommand;
			}
		}
	}
}
