﻿using System;
using System.Collections.Generic;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples.ControlExamples
{
	public class CustomDatePickerViewModel : ViewModelBase
	{
		public CustomDatePickerViewModel(Action completeAction)
		{
			for (int i = 1; i < 6; i++)
			{
				dates.Add(DateTime.Now.AddYears(i));
			}

			setDateCommand = new DelegateCommand<DateTime?>(
				dateTime =>
					{
						if (dateTime == null)
						{
							return;
						}

						Date = dateTime;

						if (completeAction != null)
						{
							completeAction();
						}
					});
		}

		readonly List<DateTime> dates = new List<DateTime>();

		public IEnumerable<DateTime> Dates
		{
			get
			{
				return dates;
			}
		}

		DateTime? date = DateTime.Now;

		public DateTime? Date
		{
			get
			{
				return date;
			}
			set
			{
				Assign(() => Date, ref date, value);
			}
		}

		readonly DelegateCommand<DateTime?> setDateCommand;

		public DelegateCommand<DateTime?> SetDateCommand
		{
			get
			{
				return setDateCommand;
			}
		}

	}
}
