﻿// (c) Copyright Microsoft Corporation.
// This source is subject to the Microsoft Public License (Ms-PL).
// Please see http://go.microsoft.com/fwlink/?LinkID=131993 for details.
// All other rights reserved.

using System.Collections.Generic;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public class Contact
	{
		public int Id { get; private set; }
		public string FirstName { get; private set; }
		public string LastName { get; private set; }

		public string FullName
		{
			get
			{
				return FirstName + " " + LastName;
			}
		}

		public string EmailAddress { get; private set; }
		public string MobileNumber { get; private set; }
		public string HomeNumber { get; private set; }
		public string ImageUrl { get; private set; }
		
		public static Contact GetRandomContact(int id)
		{
			var person = new Contact
			             	{
			             		Id = id,
			             		FirstName = RandomContactGenerator.GetRandomFirstName(),
			             		LastName = RandomContactGenerator.GetRandomLastName(),
			             		MobileNumber = RandomContactGenerator.GetRandomPhoneNumber(),
			             		HomeNumber = RandomContactGenerator.GetRandomPhoneNumber(),
								ImageUrl = "/ControlExamples/SilverlightToolkit/LongListSelector/ContactsViewer/Images/ContactIcon.png"
			             	};

			person.EmailAddress = person.FirstName + "@example.com";

			return person;
		}

		public static IEnumerable<Contact> GetRandomContacts(int numberToCreate)
		{
			ArgumentValidator.AssertGreaterThan(0, numberToCreate, "numberToCreate");
			for (int i = 0; i < numberToCreate; i++)
			{
				yield return GetRandomContact(i);
			}
		}

	}
}