﻿using System;
using System.Collections.Generic;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples.ControlExamples
{
	public class MarketplaceApp
	{
		static readonly Random random = new Random();
		public string Name { get; private set; }
		public string Description { get; private set; }
		public string ImageUrl { get; private set; }
		public double Price { get; private set; }
		public string Category { get; private set; }

		public MarketplaceApp(string name, string description, 
		                      string category, double price, string imageUrl)
		{
			Name = name;
			Description = description;
			Category = category;
			Price = price;
			ImageUrl = imageUrl;
		}

		static readonly string[] categories 
			= { "Games", "Photo", "Social", "Business", "Tools", "Travel" };

		static readonly double[] prices
			= { 0.99, 1.99, 2.99, 5.99 };

		public static MarketplaceApp CreateRandomApp()
		{
			string name = LoremIpsumGenerator.GetWords(
							random.Next(1, 5), 
			                LoremIpsumGenerator.Capitalization.AllWords);
			string description = LoremIpsumGenerator.GetParagraph(random.Next(3, 7));
			string category = categories[random.Next(6)];
			double price = prices[random.Next(4)];
			MarketplaceApp result = new MarketplaceApp(
				name, description, category, price, 
				"/ControlExamples/SilverlightToolkit/LongListSelector/MarketplaceAppList/Images/MarketplaceAppIcon.png");
			return result;
		}

		public static IEnumerable<MarketplaceApp> CreateRandomApps(int numberToCreate)
		{
			ArgumentValidator.AssertGreaterThan(0, numberToCreate, "numberToCreate");
			for (int i = 0; i < numberToCreate; i++)
			{
				yield return CreateRandomApp();
			}
		}
	}
}