﻿using System;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using Microsoft.Phone.Controls;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public partial class ManipulationEventsView : PhoneApplicationPage
	{
		readonly SolidColorBrush startManipulationBrush = new SolidColorBrush(Colors.Orange);
		Brush normalBrush;

		public ManipulationEventsView()
		{
			InitializeComponent();
		}

		void HandleManipulationStarted(object sender, ManipulationStartedEventArgs e)
		{
			Border border = (Border)sender;
			normalBrush = border.Background;
			border.Background = startManipulationBrush;
		}

		void HandleManipulationDelta(object sender, ManipulationDeltaEventArgs e)
		{
			TextBlock_Message.Text = string.Format(
				"Scale X{0:00.00},Y{1:00.00} \n Translation X{2:00},Y{3:00} \n ManipulationOrigin X{4:00}, Y{5:00}",
				e.DeltaManipulation.Scale.X,
				e.DeltaManipulation.Scale.Y,
				e.DeltaManipulation.Translation.X,
				e.DeltaManipulation.Translation.Y,
				e.ManipulationOrigin.X,
				e.ManipulationOrigin.Y);

			compositeTransform.TranslateX += e.DeltaManipulation.Translation.X;
			compositeTransform.TranslateY += e.DeltaManipulation.Translation.Y;

			if (e.DeltaManipulation.Scale.X > 0
				&& e.DeltaManipulation.Scale.Y > 0)
			{
				compositeTransform.ScaleX *= e.DeltaManipulation.Scale.X;
				compositeTransform.ScaleY *= e.DeltaManipulation.Scale.Y;
			}
		}

		void HandleManipulationCompleted(object sender, ManipulationCompletedEventArgs e)
		{
			Border border = (Border)sender;
			border.Background = normalBrush;
			TextBlock_Message.Text = string.Empty;

			if (e.IsInertial)
			{
				Debug.WriteLine("IsInertial: " + e.IsInertial);
			}
		}

		void HandleManipulationStartedAtPageLevel(object sender, ManipulationStartedEventArgs e)
		{
			Debug.WriteLine("Manipulation started at page level.");
		}
	}
}