﻿using System;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using Microsoft.Phone.Controls;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public partial class MouseEventsView : PhoneApplicationPage
	{
		readonly SolidColorBrush dragBrush = new SolidColorBrush(Colors.Orange);
		readonly SolidColorBrush normalBrush;

		public MouseEventsView()
		{
			InitializeComponent();

			normalBrush = (SolidColorBrush)Resources["PhoneAccentBrush"];
		}

		void HandleLeftButtonDown(object sender, MouseButtonEventArgs e)
		{
			Border border = (Border)sender;
			border.Background = dragBrush;
		}

		void HandleLeftButtonUp(object sender, MouseButtonEventArgs e)
		{
			Border border = (Border)sender;
			border.Background = normalBrush;
		}

		void HandleMouseLeave(object sender, MouseEventArgs e)
		{
			Border border = (Border)sender;
			border.Background = normalBrush;
			Debug.WriteLine("MouseLeave event raised.");
		}
	}
}