﻿using System;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using Microsoft.Phone.Controls;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public partial class TouchPointView : PhoneApplicationPage
	{
		readonly SolidColorBrush directlyOverBrush = new SolidColorBrush(Colors.Orange);
		readonly Brush normalBrush;

		public TouchPointView()
		{
			InitializeComponent();

			normalBrush = border.Background;

			Touch.FrameReported += HandleFrameReported;
		}

		void HandleFrameReported(object sender, TouchFrameEventArgs e)
		{
			TouchPoint primaryTouchPoint = e.GetPrimaryTouchPoint(null);

			if (primaryTouchPoint == null 
				|| primaryTouchPoint.TouchDevice.DirectlyOver != border)
			{
				return;
			}
			
			if (primaryTouchPoint.Action == TouchAction.Down)
			{
				border.Background = directlyOverBrush;
			}
			else
			{
				border.Background = normalBrush;
			}
		}
			
	}
}