﻿using System;
using System.IO;
using System.Windows;
using System.Windows.Navigation;
using System.Windows.Resources;

using Microsoft.Phone.Controls;

namespace DanielVaughan.WindowsPhone7Unleashed.Examples
{
	public partial class WebBrowserWithScriptingView : PhoneApplicationPage
	{
		public WebBrowserWithScriptingView()
		{
			InitializeComponent();
			DataContext = new WebBrowserWithScriptingViewModel();
		}

		void WebBrowser_ScriptNotify(object sender, NotifyEventArgs e)
		{
			MessageBox.Show(e.Value, "Received Value", MessageBoxButton.OK);
		}

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
            StreamResourceInfo streamResourceInfo = Application.GetResourceStream(
                new Uri("WebBrowser/Webpage.html", UriKind.Relative));

            string html;
            using (StreamReader reader = new StreamReader(streamResourceInfo.Stream))
            {
                html = reader.ReadToEnd();
            }
            webBrowser.NavigateToString(html);
        }

		void Button_SendToPage_Tap(object sender, System.Windows.Input.GestureEventArgs e)
		{
			webBrowser.InvokeScript("Populate", textBox.Text);
		}

		void Button_InjectScript_Tap(object sender, System.Windows.Input.GestureEventArgs e)
		{
			webBrowser.InvokeScript("eval", evalScript);
		}

		const string evalScript =
			@"var anchors = document.getElementsByTagName('a');
					
				for(var i = 0; i < anchors.length; i++)
				{
					var anchor = anchors[i];
					anchor.attachEvent('onclick', function() 
						{	
							anchor.innerHTML = 'This text was changed by attaching' 
											+ ' an event handler from Silverlight!';
						});
				}";

		void webBrowser_Navigating(object sender, NavigatingEventArgs e)
		{
			if (e.Uri.ToString().IndexOf("www.example.com", 
				StringComparison.CurrentCultureIgnoreCase) != -1)
			{
				e.Cancel = true;
			}
		}

		void webBrowser_Navigated(object sender, NavigationEventArgs e)
		{

		}
	}
}