﻿using System.Windows;

using DanielVaughan.WindowsPhone7Unleashed.Examples;
using DanielVaughan.WindowsPhone7Unleashed.Examples.BingMaps.Routing;

using Microsoft.Phone.Controls.Maps;
using Microsoft.Silverlight.Testing;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace DanielVaughan.WindowsPhone7Unleashed.BingMaps
{
	[TestClass]
	[Tag("Route")]
	public class RouteCalculatorTests : SilverlightTest
	{
		readonly CredentialsProvider credentialsProvider
					= new ApplicationIdCredentialsProvider(App.BingMapsId);

		[TestMethod]
		[Asynchronous]
		public void RouteCalculatorShouldGenerateRoute()
		{
			RouteCalculator calculator = new RouteCalculator(credentialsProvider);
			calculator.CalculateAsync(
				"Bangalay Cres Rivett ACT Australia",
				"Scratchley Place Monash ACT Australia", 
					args =>
						{
							/* This assert fails if you have not set your Bing Maps id 
							 * in the App.xaml.cs file in the WindowsPhone7Unleashed.Examles project. */
							Assert.IsNull(args.Error, "Be sure to set the BingMapsId constant in the App.xaml.cs file" 
								+ " in the WindowsPhone7Unleashed.Examles project.");
							Assert.IsNotNull(args.RouteResult);
							EnqueueTestComplete();
			            });
		}
	}
}
