﻿using System;
using System.Threading;
using System.Windows;
using System.Windows.Automation.Peers;
using System.Windows.Automation.Provider;

using DanielVaughan.Windows;

using Microsoft.Silverlight.Testing;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	[TestClass]
	public class ChatClientUITests : SilverlightTest
	{
		ChatClientView view;

		[TestInitialize]
		public void PreparePage()
		{
			view = new ChatClientView();
			TestPanel.Children.Add(view);
		}

		[TestMethod]
		public void ShouldDisplayDefaultSize()
		{
			Assert.IsTrue(view.ActualWidth > 0);
		}

		[TestMethod]
		public void ButtonShouldBeEnabled()
		{
			view.textBlock_Message.Text = "Test";
			Assert.IsTrue(view.button_Send.IsEnabled);
		}

		[TestMethod]
		[Asynchronous]
		public void ButtonShouldSendMessage()
		{
			view.textBlock_Message.Text = "Test";
			EnqueueCallback(() => ((IAppBarItem)view.button_Send).PerformClick());
			EnqueueCallback(() => Assert.IsTrue(view.listBox.Items.Count > 0));
			EnqueueTestComplete();
		}

		[TestMethod]
		[Asynchronous]
		public void DemonstrateButtonTap()
		{
			AutomationPeer peer = FrameworkElementAutomationPeer.CreatePeerForElement(
													view.button_AutomationTest);
			IInvokeProvider provider = (IInvokeProvider)peer.GetPattern(
													PatternInterface.Invoke);
			provider.Invoke();

			EnqueueCallback(() => Assert.IsTrue(view.ButtonClicked));
			EnqueueTestComplete();
		}
	}
}
