﻿using System.Collections.Generic;
using System.ComponentModel;
using System.Reflection;
using System.Windows;
using System.Windows.Navigation;

using Microsoft.Phone.Shell;
using Microsoft.Silverlight.Testing;
using Microsoft.Silverlight.Testing.Client;

namespace WindowsPhone7Unleashed.Tests
{
	public partial class MainPage
	{
		public MainPage()
		{
			InitializeComponent();
		}

	    IMobileTestPage mobileTestPage;

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            SystemTray.IsVisible = false;

            /* To avoid the countdown timer and the tag expression being shown, 
             * uncomment the following. (Does not work in the current release) */
            // UnitTestSettings settings = UnitTestSystem.CreateDefaultSettings();
            // settings.TestService = null;                    
            // settings.StartRunImmediately = true;
            /* Does not hide editor. */
            // settings.ShowTagExpressionEditor = false;          			
            // UIElement testPage = UnitTestSystem.CreateTestPage(settings);

            /* This does not work either: */
            // MobileTestPage testPage = (MobileTestPage)UnitTestSystem.CreateTestPage();
            // testPage.UnitTestHarness.Settings.ShowTagExpressionEditor = false;
            // testPage.UnitTestHarness.Settings.StartRunImmediately = true;
            
            UnitTestSettings settings = UnitTestSystem.CreateDefaultSettings();
            /* To set the TagExpression use the following: */
            // UnitTestSettings settings = UnitTestSystem.CreateDefaultSettings();
            // settings.TagExpression = "UnitTest";

            /* Add test assemblies as shown: */
            // settings.TestAssemblies.Add(typeof(Class1).Assembly);
            // settings.TestAssemblies.Add(typeof(TestClass2).Assembly);

            UIElement testPage = UnitTestSystem.CreateTestPage();
            			
            Application.Current.RootVisual = testPage;
            Application.Current.Host.Settings.EnableFrameRateCounter = false;

            mobileTestPage = testPage as IMobileTestPage;
        }

        protected override void OnBackKeyPress(CancelEventArgs e)
        {
            if (mobileTestPage != null)
            {
                e.Cancel = mobileTestPage.NavigateBack();
            }

            base.OnBackKeyPress(e);
        }
	}
}
