﻿using System;
using System.Runtime.Serialization;
using System.Xml.Linq;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	[DataContract]
	public class Product
	{
		[DataMember]
		public int Id { get; set; }

		[DataMember]
		public string Title { get; set; }

		[DataMember]
		public string Description { get; set; }

		[DataMember]
		public string SmallImageUri { get; set; }

		[DataMember]
		public string LargeImageUri { get; set; }

		[DataMember]
		public double Price { get; set; }

		[DataMember]
		public string Author { get; set; }

		[DataMember]
		public string Isbn10 { get; set; }

		[DataMember]
		public string Isbn13 { get; set; }

		[DataMember]
		public string ExternalUrl { get; set; }


		public Product()
		{
			/* Intentionally left blank. */
		}

		public Product(XElement element)
		{
			if (element == null)
			{
				throw new ArgumentNullException("element");
			}
			Id = (int)element.Element("Id");
			Title = (string)element.Element("Title");
			Author = (string)element.Element("Author");
			Description = (string)element.Element("Description");
			SmallImageUri = (string)element.Element("SmallImageUri");
			LargeImageUri = (string)element.Element("LargeImageUri");
			Price = (double)element.Element("Price");
			Isbn10 = (string)element.Element("ISBN-10");
			Isbn13 = (string)element.Element("ISBN-13");
			ExternalUrl = (string)element.Element("ExternalUrl");
		}
	}
}