﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Xml.Linq;

namespace DanielVaughan.WindowsPhone7Unleashed.Web.Services.Bookshop
{
	public static class ProductManager
	{
		static readonly List<Product> products = new List<Product>();

		public static IEnumerable<Product> Products
		{
			get
			{
				return products;
			}
		}

		static ProductManager()
		{
			string path = HttpContext.Current.Server.MapPath(
				"~/Services/Bookshop/Products.xml");
			XDocument document = XDocument.Load(path);
			foreach (XElement element in
				document.Element("Products").Elements("Product"))
			{
				var product = new Product(element);
				product.SmallImageUri
					= ServerUtility.ResolveServerUrl(product.SmallImageUri);
				product.LargeImageUri
					= ServerUtility.ResolveServerUrl(product.LargeImageUri);
				products.Add(product);
			}
		}

		public static Product GetProductById(int id)
		{
			if (id < 0 || id > products.Count)
			{
				throw new ArgumentOutOfRangeException("id");
			}
			return products[id - 1];
		}
	}
}
