using System;

namespace DanielVaughan.WindowsPhone7Unleashed
{
	public enum NotificationStatus
	{
		Received,
		NotApplicable,
		QueueFull,
		Dropped,
		Suppressed
	}

	public enum DeviceConnectionStatus
	{
		Connected,
		TemporarilyDisconnected,
		Disconnected,
		Inactive,
		NotApplicable
	}

	public enum SubscriptionStatus
	{
		Active,
		NotApplicable,
		Expired
	}

	public enum PushNotificationPriority
	{
		Regular,
		Priority,
		RealTime
	}

	public static class PushNotificationEnumConverter
	{
		public static SubscriptionStatus ToSubscriptionStatus(string subscriptionStatus)
		{
			string statusLower = subscriptionStatus.ToLower();
			switch (statusLower)
			{
				case "active":
					return SubscriptionStatus.Active;
				case "expired":
					return SubscriptionStatus.Expired;
				default:
					throw new ArgumentException("Unknown SubscriptionStatus:" + subscriptionStatus);
			}
		}

		public static DeviceConnectionStatus ToDeviceConnectionStatus(string deviceConnectionStatus)
		{
			string statusLower = deviceConnectionStatus.ToLower();
			switch (statusLower)
			{
				case "connected":
					return DeviceConnectionStatus.Connected;
				case "tempdisconnected":
					return DeviceConnectionStatus.TemporarilyDisconnected;
				case "disconnected":
					return DeviceConnectionStatus.Disconnected;
				case "inactive":
					return DeviceConnectionStatus.Inactive;
				default:
					throw new ArgumentException("Unknown DeviceConnectionStatus:" + deviceConnectionStatus);
			}
		}

		public static NotificationStatus ToNotificationStatus(string notificationStatus)
		{
			string statusLower = notificationStatus.ToLower();
			switch (statusLower)
			{
				case "received":
					return NotificationStatus.Received;
				case "queuefull":
					return NotificationStatus.QueueFull;
				case "dropped":
					return NotificationStatus.Dropped;
				case "suppressed":
					return NotificationStatus.Suppressed;
				default:
					throw new ArgumentException("Unknown NotificationStatus:" + notificationStatus);
			}
		}
	}
}