﻿using System.Windows.Input;

using DanielVaughan.WindowsPhone7Unleashed;

using Microsoft.Xna.Framework;

namespace SilverlightXnaHybrid
{
	public class GamePageViewModel : ViewModelBase
	{
		public GamePageViewModel()
		{
			modelMetadata = new ModelMetadata
			{
				Asset = "Spaceship",
				Name = "Spaceship",
				Description = "Alien spaceship model",
				World = Matrix.Identity,
				ViewMatrix = Matrix.CreateLookAt(
					new Vector3(3500, 400, 0) + new Vector3(0, 250, 0),
					new Vector3(0, 250, 0),
					Vector3.Up),
				FieldOfViewDivisor = 1f,
				AspectRatio = 1.66666663f,
				NearPlaneDistance = 10f,
				FarPlaneDistance = 20000f,
			};

			displayMessageCommand = new DelegateCommand(
											obj => Message = "Silverlight Message");
		}

		ModelMetadata modelMetadata;

		public ModelMetadata ModelMetadata
		{
			get
			{
				return modelMetadata;
			}
			private set
			{
				Assign(() => ModelMetadata, ref modelMetadata, value);
			}
		}

		string message;

		public string Message
		{
			get
			{
				return message;
			}
			set
			{
				Assign(() => Message, ref message, value);
			}
		}

		readonly DelegateCommand displayMessageCommand;

		public ICommand DisplayMessageCommand
		{
			get
			{
				return displayMessageCommand;
			}
		}
	}
}
